/*===================================< adjlista.c >================================*/
/* Lavoro derivato dalla omonima libreria di Roberto A. Foglietta
 * (C) 2003  Paolo Bongiorno Leave under GPL 01/10/03 */
#include "adj_lista.h"
#include <gtk/gtk.h>

GtkObject *
get_selected_list_item (GtkWidget * container, const char *widget)
{
  GtkWidget *lst;
  GList *dlist;
  GtkObject *list_item;

  list_item = NULL;

  lst = lookup_widget (container, widget);
  dlist = GTK_LIST (lst)->selection;

  while (dlist)
       { list_item = GTK_OBJECT (dlist->data);
         dlist = dlist->next;
        }

  return list_item;
}

void
set_scrolled_window (GtkWidget * container, const char *scrolledwindow,
		                                     const char *lista)
{
  GtkAdjustment *Adj;
  GtkObject *lista_item;
  GtkWidget *scrollbar;
  gint scroll_y;
  int y1, y2, start;

  lista_item = get_selected_list_item (container, lista);
  
  scroll_y = GTK_WIDGET (lista_item)->allocation.y;

  scrollbar = lookup_widget (container, scrolledwindow);

  Adj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW (scrollbar));

  y1 = (int) (scroll_y / Adj->page_size);
  y2 = (int) ((scroll_y + Adj->step_increment) / Adj->page_size);

   /* se sono diversi significa che sta a cavallo di due pagine */
  if (y1 == y2)
      start = y1 * Adj->page_size;
  else
      start = scroll_y;

  if (start != Adj->value)
    {
      if (start >= 0)
         {
           if (start + Adj->page_size > Adj->upper)
	    start = Adj->upper - Adj->page_size;
	    Adj->value = start;
	    gtk_scrolled_window_set_vadjustment (GTK_SCROLLED_WINDOW (scrollbar), Adj);
	    gtk_adjustment_value_changed (Adj);
          }
      else
       g_print ("\nERRORE: start vale %d ma deve essere un intero positivo", start);
    }

} 
