#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cattura_txt.c"
#include "lists_loader.c"
#include "adj_lista.c"
#include <gdk/gdkkeysyms.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "freeze.c"
#include "combo_loader.c"
#include "info_label.c"
#include "cls_user.c"
#include "elementi_user.c"
#include "clist_loader.c"
#include "restore.c"
#include "upper.c"
#include "somma_totali.h"
#include "riepilogo.c"
#include "anagr.c"
#include "ricevuta.c"
#include "iofile.c"
#include "date_in.c"
#include "cls_var.c"


/* Questo puntatore conterr gli elementi della list3
 * nel widget ana_user */
PGresult *Res_User;
/* Record della list3 */
gint Record_User;

/* Questo puntatore conterr gli elementi della list4
 * nel widget gadget */
PGresult *Res_gad;
/* Record della list4 */
gint Record_gad;

/* Puntatore alla selezione della combo tipologie */
PGresult *Res_combo_tipo;

/* Puntatore alla selezione della combo gadgets */
PGresult *Res_combo_gad;

/* Questo puntatore conterr gli elementi della list5
 * nel widget collaborazioni */
PGresult *Res_tipol;
/* Record della list4 */
gint Record_tipol;

/* Variabili globali per il confronto
 * in variazione */
gchar *GADGET;
gchar *PREZZO;
gchar *GADGET_VAR = NULL;
gchar *PREZZO_VAR = NULL;

/* Tipologie di collaborazioni e
 * e variabili di servizio */
gchar *TIPOLOGIA;
gchar *TIPOLOGIA_VAR;
gchar *MOV_CASSA;
gchar *MOV_LUG;
gchar *COME_GAD;
gint CHANGED = 0;

/* Ultimo bottone premuto nell' informatore
   mi serve per la memoria del suo colore */
const gchar *Last_Button;

/* Numero globale di items nella list3 */
gint List3_Items;

gboolean
on_deskbase_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{ exit_yn = create_exit_yn();
  gtk_widget_show(exit_yn);
  gdk_beep();
  return TRUE;
}


void
on_tariffa_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ ana_user = create_ana_user();
  gtk_widget_show(ana_user);
  ghiaccia(ana_user,user_save,"user_save",0);
  ghiaccia(deskbase,btt_desk_anagr,"btt_desk_anagr",0);
  ghiaccia(deskbase,tariffa,"tariffa",0);
}


void
on_uscita2_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ exit_yn = create_exit_yn();
  gtk_widget_show(exit_yn);
  gdk_beep();
}


void
on_stampa_fattura1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ stamp = create_stamp();
  gtk_widget_show(stamp);
}



void
on_server_postgres1_activate           (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  db_conn = create_db_conn();
  gtk_widget_show(db_conn);
}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ GtkWidget *About;
  About = create_About();
  gtk_widget_show(About);
}


void
on_licenza_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{ GtkWidget *text2;
  GdkFont *fixed_font;
  gchar *buf;
  long lun;
  GdkColormap *cmap = NULL;
  GdkColor color;

  lc_view = create_lc_view();
  gtk_widget_show(lc_view);
  fixed_font = gdk_font_load ("-misc-fixed-medium-r-*-*-*-100-*-*-*-*-*-*");
  //fixed_font = gdk_font_load ("-misc-fixed-medium-r-semicondensed-*-*-110-*-*-c-*-iso10646-1");
  text2 = lookup_widget(lc_view,"text2");

  setcolor(100,149,237, text2, "bg_normal");

  cmap = gdk_colormap_get_system();
  color.red = 0;
  color.green = 0x1fff;
  color.blue = 0xffff;
  if (!gdk_color_alloc(cmap, &color)) {
      g_error("Non posso allocare il colore");
  }

  buf = read_file_to_buffer ("gpl_it.txt", "r", &lun);
  gtk_text_insert (GTK_TEXT (text2), fixed_font, &color,\
                   NULL, buf, -1);


}

void
on_btt_desk_anagr_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{ ana_user = create_ana_user();
  gtk_widget_show(ana_user);
  ghiaccia(ana_user,user_save,"user_save",0);
  ghiaccia(deskbase,btt_desk_anagr,"btt_desk_anagr",0);
  ghiaccia(deskbase,tariffa,"tariffa",0);
}


void
on_btt_desk_user_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *comando;
  PGresult *res;
  gint n_tuple;

  Informatore = create_Informatore();
  gtk_widget_show(Informatore);

  comando = strdup("SELECT nome,email,tel FROM utenti ORDER BY nome");
  res = PQexec(connessione,comando);

  n_tuple = PQntuples(res);
  if (n_tuple > 0 )
    load_clist(res,n_tuple);
}


void
on_btt_desk_col_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{ collaborazioni = create_collaborazioni();
  gtk_widget_show(collaborazioni);
  ghiaccia(deskbase,btt_desk_col,"btt_desk_col",0);
  ghiaccia(collaborazioni,save_tipo,"save_tipo",0);
}


void
on_btt_desk_cassa_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *tipologia;
  gchar *totale;
  gchar comando[200];
  PGresult *res_tipo;
  GtkWidget *combo23;
  GtkWidget *entry6;
  int  n_tuple;

  totali_cassa = create_totali_cassa();
  gtk_widget_show(totali_cassa);

  /* Combo box */
  combo23 = lookup_widget(totali_cassa,"combo23");
  sprintf(comando,"SELECT nome FROM tipologie ORDER BY nome");
  res_tipo = PQexec(connessione,comando);
  n_tuple = PQntuples(res_tipo);
  if (n_tuple > 0 )
    load_combo(comando,combo23);

  tipologia = get_testo(totali_cassa,"combo_totale");

   if (tipologia)
     { sprintf(comando,"SELECT sum(euro) from utenti where tipo_c='%s';",tipologia);
       res_tipo = PQexec(connessione,comando);
       totale = PQgetvalue(res_tipo,0,0);
       entry6 = lookup_widget(totali_cassa,"entry6");
       gtk_entry_set_text (GTK_ENTRY (entry6),totale);
     }
}


void
on_btt_desk_print_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{ stamp = create_stamp();
  gtk_widget_show(stamp);
}


void
on_desk_gad_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ 
  anagrafica = create_anagrafica();
  gtk_widget_show(anagrafica);
  prd_save = lookup_widget(anagrafica,"prd_save");
  gtk_widget_set_sensitive(GTK_WIDGET(prd_save),FALSE);
  ghiaccia(deskbase,desk_gad,"desk_gad",0);
}


void
on_open_data_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ database = create_database();
  gtk_widget_show(database);
  ghiaccia(database,data_button_sel,"data_button_sel",0);
  ghiaccia(deskbase,open_data,"open_data",0);
}


void
on_infop_btt_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ GtkWidget *About;
  About = create_About();
  gtk_widget_show(About);
}


void
on_uscita_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  exit_yn = create_exit_yn();
  gtk_widget_show(exit_yn);
  gdk_beep();
}


gboolean
on_Informatore_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  return FALSE;
}


void
on_button_A_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_A;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_A");

  button_A = lookup_widget(GTK_WIDGET(Informatore),"button_A");
  setcolor(255,255,0, button_A, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'A%s'\
          ORDER BY nome;",perc);
  res = PQexec(connessione,comando);

  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_B_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_B;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_B");

  button_B = lookup_widget(GTK_WIDGET(Informatore),"button_B");
  setcolor(255,255,0, button_B, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'B%s'\
          ORDER BY nome;",perc);
  res = PQexec(connessione,comando);

  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_C_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_C;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_C");

  button_C = lookup_widget(GTK_WIDGET(Informatore),"button_C");
  setcolor(255,255,0, button_C, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'C%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_D_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_D;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_D");

  button_D = lookup_widget(GTK_WIDGET(Informatore),"button_D");
  setcolor(255,255,0, button_D, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'D%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_E_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_E;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_E");

  button_E = lookup_widget(GTK_WIDGET(Informatore),"button_E");
  setcolor(255,255,0, button_E, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'E%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_F_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_F;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_F");

  button_F = lookup_widget(GTK_WIDGET(Informatore),"button_F");
  setcolor(255,255,0, button_F, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'F%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_G_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_G;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_G");

  button_G = lookup_widget(GTK_WIDGET(Informatore),"button_G");
  setcolor(255,255,0, button_G, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'G%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_H_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_H;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_H");

  button_H = lookup_widget(GTK_WIDGET(Informatore),"button_H");
  setcolor(255,255,0, button_H, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'H%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_I_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_I;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_I");

  button_I = lookup_widget(GTK_WIDGET(Informatore),"button_I");
  setcolor(255,255,0, button_I, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'I%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_J_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_J;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_J");

  button_J = lookup_widget(GTK_WIDGET(Informatore),"button_J");
  setcolor(255,255,0, button_J, "bg_normal"); 
  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'J%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_K_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_K;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_K");

  button_K = lookup_widget(GTK_WIDGET(Informatore),"button_K");
  setcolor(255,255,0, button_K, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'K%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_L_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_L;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_L");

  button_L = lookup_widget(GTK_WIDGET(Informatore),"button_L");
  setcolor(255,255,0, button_L, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'L%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_M_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_M;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_M");

  button_M = lookup_widget(GTK_WIDGET(Informatore),"button_M");
  setcolor(255,255,0, button_M, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'M%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_N_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_N;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_N");

  button_N = lookup_widget(GTK_WIDGET(Informatore),"button_N");
  setcolor(255,255,0, button_N, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'N%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_O_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_O;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_O");

  button_O = lookup_widget(GTK_WIDGET(Informatore),"button_O");
  setcolor(255,255,0, button_O, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'O%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_P_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_P;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_P");

  button_P = lookup_widget(GTK_WIDGET(Informatore),"button_P");
  setcolor(255,255,0, button_P, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'P%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");

}


void
on_button_Q_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_Q;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_Q");

  button_Q = lookup_widget(GTK_WIDGET(Informatore),"button_Q");
  setcolor(255,255,0, button_Q, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'Q%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_R_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_R;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_R");

  button_R = lookup_widget(GTK_WIDGET(Informatore),"button_R");
  setcolor(255,255,0, button_R, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'R%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_S_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_S;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_S");

  button_S = lookup_widget(GTK_WIDGET(Informatore),"button_S");
  setcolor(255,255,0, button_S, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'S%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_T_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_T;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_T");

  button_T = lookup_widget(GTK_WIDGET(Informatore),"button_T");
  setcolor(255,255,0, button_T, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'T%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_U_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_U;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_U");

  button_U = lookup_widget(GTK_WIDGET(Informatore),"button_U");
  setcolor(255,255,0, button_U, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'U%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_V_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_V;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_V");

  button_V = lookup_widget(GTK_WIDGET(Informatore),"button_V");
  setcolor(255,255,0, button_V, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'V%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_W_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_W;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_W");

  button_W = lookup_widget(GTK_WIDGET(Informatore),"button_W");
  setcolor(255,255,0, button_W, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'W%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_X_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_X;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_X");

  button_X = lookup_widget(GTK_WIDGET(Informatore),"button_X");
  setcolor(255,255,0, button_X, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'X%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_Y_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_Y;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_Y");

  button_Y = lookup_widget(GTK_WIDGET(Informatore),"button_Y");
  setcolor(255,255,0, button_Y, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'Y%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


void
on_button_Z_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *perc="%";
  gchar comando[500];
  PGresult *res;
  gint n_tuple;
  GtkWidget *ultimo = NULL;
  GtkWidget *button_Z;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  Last_Button = strdup("button_Z");

  button_Z = lookup_widget(GTK_WIDGET(Informatore),"button_Z");
  setcolor(255,255,0, button_Z, "bg_normal");

  sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE 'Z%s'\
          ORDER BY nome;",perc);

  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);

  load_clist(res, n_tuple);
  infor_entry = lookup_widget(Informatore,"infor_entry");

  gtk_window_set_focus(GTK_WINDOW(Informatore), infor_entry);
  gtk_entry_set_text (GTK_ENTRY (infor_entry), "");
}


gboolean
on_infor_entry_key_press_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ char *perc="%";
  gchar *user;
  GtkWidget *ultimo = NULL;
  PGresult *res;
  gint n_tuple;
  gchar comando[300];

  user = upper_string(get_testo(widget, "infor_entry"));
  gtk_entry_set_text(GTK_ENTRY(widget),user);

  if (Last_Button)
    { ultimo =  lookup_widget(Informatore,Last_Button);
      setcolor(211,211,211, ultimo, "bg_normal");
    }

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*user)
        { sprintf(comando,"SELECT nome,email,tel FROM utenti WHERE nome LIKE '%s%s%s'\
                  ORDER BY nome;",perc,user,perc);
          res = PQexec(connessione,comando);
          n_tuple = PQntuples(res);
          if (n_tuple > 0 )
            load_clist(res,n_tuple);
          else gdk_beep();
         }
      else gdk_beep();
    }

  return FALSE;
}


void
on_infor_close_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(Informatore);
}


void
on_info_reload_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *comando;
  GtkWidget *ultimo = NULL;
  PGresult *res;
  gint n_tuple;

  if (Last_Button) {
  ultimo =  lookup_widget(Informatore,Last_Button);
  setcolor(211,211,211, ultimo, "bg_normal"); }

  comando = strdup("SELECT nome,email,tel FROM utenti ORDER BY nome");
  res = PQexec(connessione,comando);

  n_tuple = PQntuples(res);
  if (n_tuple > 0 )
    load_clist(res,n_tuple);
}


gboolean
on_ana_user_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  ghiaccia(deskbase,btt_desk_anagr,"btt_desk_anagr",1);
  ghiaccia(deskbase,tariffa,"tariffa",1);
  return FALSE;
}


void
on_note_user_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)

{ gchar *comando;
  PGresult *res_combo;
  GtkWidget *note_user;
  int note_number, n_tuple;

  /* Prima combo box */
  combo25 = lookup_widget(ana_user,"combo25");
  comando = strdup("SELECT nome FROM tipologie ORDER BY nome");
  res_combo = PQexec(connessione,comando);
  n_tuple = PQntuples(res_combo);

  if (n_tuple > 0 )
    load_combo(comando,combo25);

  /* Seconda combo box */
  combo26 = lookup_widget(ana_user,"combo26");
  comando = strdup("SELECT nome FROM gadget ORDER BY nome");
  res_combo = PQexec(connessione,comando);
  n_tuple = PQntuples(res_combo);
  if (n_tuple > 0 )
    load_combo(comando,combo26);
  /* ____________________________ */
  note_user = lookup_widget(ana_user,"note_user");
  note_number = gtk_notebook_get_current_page(GTK_NOTEBOOK(note_user));

  if ( note_number == 0 ) {
          var_usave = lookup_widget(ana_user,"var_usave");
          gtk_widget_set_sensitive(GTK_WIDGET(var_usave),FALSE);

          comando = strdup("SELECT nome,indirizzo,citta,prov,cap,tel,fax,email,\
                            piva,tipo_c,gadget,qt,euro,data,note,id,lug\
                            FROM utenti ORDER BY nome;");
          /* Variabile globale, la sfrutto per evitare un altra SELECT
           * nel select_child */
          Res_User = PQexec(connessione,comando);
          n_tuple = PQntuples(Res_User);
          List3_Items = n_tuple;
          if (n_tuple > 0) load_list(comando, ana_user, "list3");
         }
  else {  Nome_User = NULL;
          Ind_User = NULL;
          Citta_User = NULL;
          Prov_User = NULL;
          Cap_User = NULL;
          Tel_User = NULL;
          Fax_User = NULL;
          Mail_User = NULL;
          Iva_User = NULL;
          Note_User = NULL;
          Tipo_Contr = NULL;
          Lug_User = NULL;
          Gadget = NULL;
          Gad_Qt = 0;
          Gad_Prz = 0;
       }
}


gboolean
on_nm_user_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *ind_user;
  Nome_User = upper_string(get_testo(widget, "nm_user"));
  gtk_entry_set_text (GTK_ENTRY(widget),Nome_User);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Nome_User) {
                           if ( (isalpha(*Nome_User) != 0))
                             { 
                               ind_user = lookup_widget(ana_user,"ind_user");
                               gtk_window_set_focus(GTK_WINDOW(ana_user), ind_user);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_citta_key_press_event               (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *prov;
  Citta_User = upper_string(get_testo(widget, "citta"));
  gtk_entry_set_text (GTK_ENTRY(widget),Citta_User);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Citta_User) {
                           if ( (isalpha(*Citta_User) != 0))
                             {
                               prov = lookup_widget(ana_user,"prov");
                               gtk_window_set_focus(GTK_WINDOW(ana_user), prov);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_prov_key_press_event                (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *cap;
  Prov_User = upper_string(get_testo(widget, "prov"));
  gtk_entry_set_text (GTK_ENTRY(widget),Prov_User);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Prov_User) {
                           if ( (isalpha(*Prov_User) != 0))
                             {
                               cap = lookup_widget(ana_user,"cap");
                               gtk_window_set_focus(GTK_WINDOW(ana_user), cap);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_cap_key_press_event                 (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *tel;
  gint c;
  Cap_User = get_testo(widget, "cap");

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Cap_User)
        {  if ( (c = isalpha(*Cap_User) != 0)) gdk_beep();
	   else {  tel = lookup_widget(ana_user,"tel");
                   gtk_window_set_focus(GTK_WINDOW(ana_user), tel);
		 }
        }
      else  gdk_beep();
 }

  return FALSE;
}


gboolean
on_tel_key_press_event                 (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *fax;
  gint c;
  Tel_User = get_testo(widget, "tel");

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Tel_User) 
        {  if ( (c = isalpha(*Tel_User) != 0)) gdk_beep();
	   else {  fax = lookup_widget(ana_user,"fax");
                   gtk_window_set_focus(GTK_WINDOW(ana_user), fax);
		 }
        }
      else  gdk_beep();
    }

  return FALSE;
}


gboolean
on_fax_key_press_event                 (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *email;
  gint c;
  Fax_User = get_testo(widget, "fax");

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Fax_User)
        {  if ( (c = isalpha(*Fax_User) != 0)) gdk_beep();
	   else {  email = lookup_widget(ana_user,"email");
                   gtk_window_set_focus(GTK_WINDOW(ana_user), email);
		 }
        }
      else  gdk_beep();
    }

  return FALSE;
}


gboolean
on_email_key_press_event               (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *piva;
  Mail_User = get_testo(widget, "email");

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Mail_User) {
                           if ( (isalpha(*Mail_User) != 0))
                             {
                               piva = lookup_widget(ana_user,"piva");
                               gtk_window_set_focus(GTK_WINDOW(ana_user), piva);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_piva_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *note_text;
  gint c;
  Iva_User = get_testo(widget, "piva");

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
  { if ( (c = isalpha(*Iva_User) != 0)) gdk_beep();
    else { note_text  = lookup_widget(ana_user,"note_text");
           gtk_text_set_editable (GTK_TEXT (note_text), TRUE);
           Note_User = strdup("Nessuna");
           Gadget = strdup("Nessuno");
           Tipo_Contr = strdup("Nessuno");
           Lug_User = strdup("NO");
           Gad_Qt = 0;
           sprintf(Gd_Prz,"0");
           if (Iva_User == NULL) Iva_User = strdup("Nessuna");
           if (Fax_User == NULL) Fax_User = strdup("Nessuno");
           /* Porto il focus su note_text */
           gtk_widget_grab_focus (note_text);
           /* Salva = True se .. */
           if (Nome_User)
            if (Ind_User)
             if (Citta_User)
              if (Prov_User)
               if (Cap_User)
                if (Tel_User)
                 if (Mail_User)
                   ghiaccia(ana_user,user_save,"user_save",1);
        }
   }

  return FALSE;
}


void
on_btt_contrib_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{ GtkWidget *combo22;
  GtkWidget *combo24;
  GtkWidget *entry_qt;
  GtkWidget *entry_euro;
  gchar *p_prezzo;
  gchar comando[200];
  gchar comando2[200];
  gint vero = 0, n_tuple;
  
  Nome_User = get_testo(ana_user,"nm_user");
  Ind_User = get_testo(ana_user,"ind_user");
  Citta_User = get_testo(ana_user,"citta");

  if (*Nome_User)
   if (*Ind_User)
    if (*Citta_User)
     vero = 1;

  if (vero)
   { Contribuzione = create_Contribuzione();
     gtk_widget_show(Contribuzione);
     ghiaccia(ana_user,user_save,"user_save",0);
     combo22 = lookup_widget(Contribuzione,"combo22");
     combo24 = lookup_widget(Contribuzione,"combo24");
     entry_qt = lookup_widget(Contribuzione,"entry_qt");
     entry_euro = lookup_widget(Contribuzione,"entry_euro");
     /* Comando */
     sprintf(comando,"SELECT nome FROM tipologie ORDER BY nome");
     Res_combo_tipo = PQexec(connessione,comando);
     n_tuple = PQntuples(Res_combo_tipo);
     if (n_tuple > 0 )
       load_combo(comando,combo22);
     /* Comando2 */
     sprintf(comando2,"SELECT nome FROM gadget ORDER BY nome");
     Res_combo_gad = PQexec(connessione,comando2);
     n_tuple = PQntuples(Res_combo_gad);
     if (n_tuple > 0 )
       load_combo(comando2,combo24);
     gtk_entry_set_text (GTK_ENTRY (entry_qt),"1");

     /* Il separatore del prezzo da iserire deve essere "." */
         for ( p_prezzo = Gd_Prz;*p_prezzo;p_prezzo++)
            if (*p_prezzo == ',') *p_prezzo = '.';

         gtk_entry_set_text (GTK_ENTRY (entry_euro),Gd_Prz);
     }
     else { info = create_info();
            gdk_beep();
            info_label = lookup_widget(info,"info_label");
            gtk_label_set(GTK_LABEL(info_label),"Dati Insufficienti");
            gtk_widget_show(info);
           }
}


void
on_anafar_close_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{ gtk_widget_destroy(ana_user);
  ghiaccia(deskbase,btt_desk_anagr,"btt_desk_anagr",1);
  ghiaccia(deskbase,tariffa,"tariffa",1);
}


gboolean
on_find_user_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)

{ gchar *percento="%";
  char *user;
  gchar comando[200];
  int n_tuple;
  user = upper_string(get_testo(widget, "find_user"));
  gtk_entry_set_text (GTK_ENTRY(widget),user);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*user) {
        if ( (isalpha(*user) != 0))
            { sprintf(comando,"SELECT * FROM utenti WHERE nome LIKE\
                      '%s%s%s' ORDER BY id;",percento,user,percento);
              Res_User = PQexec(connessione,comando);
              n_tuple = PQntuples(Res_User);
              List3_Items = n_tuple;
              if (n_tuple > 0) load_list(comando, ana_user, "list3");
            }
         else gdk_beep();
        }
     else  gdk_beep();
   }
  return FALSE;
}


void
on_list3_select_child                  (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{ gint selezione_3;
  gchar *stringa;
  stringa = (gchar *) gtk_object_get_data((list->selection)->data,\
                                             "Return_Value");
  selezione_3 = atoi(stringa);
  load_elementi(Res_User,selezione_3);

  /* Questa funzione setta lo scrolling della lista */
  set_scrolled_window(ana_user,"scrolledwindow51","list3");
  /* Fa in modo che durante lo scrolling non venga eseguito il changed */
  CHANGED = 0;

}


gboolean
on_vr_nmuser_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  Var_Nome = upper_string(get_testo(widget,"vr_nmuser"));
  gtk_entry_set_text (GTK_ENTRY(widget),Var_Nome);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Var_Nome) {
                           if ( (isalpha(*Var_Nome) != 0))
                             {
                               if ( strcmp(Var_Nome,Nome_User) != 0 )
                               var_usave = lookup_widget(widget,"var_usave");
                               gtk_widget_set_sensitive(GTK_WIDGET(var_usave),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_vr_induser_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  Var_Ind = upper_string(get_testo(widget,"vr_induser"));
  gtk_entry_set_text (GTK_ENTRY(widget),Var_Ind);
   if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Var_Ind) {
                           if ( (isalpha(*Var_Ind) != 0))
                             {
                               if ( strcmp(Var_Ind,Ind_User) != 0 )
                               var_usave = lookup_widget(widget,"var_usave");
                               gtk_widget_set_sensitive(GTK_WIDGET(var_usave),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_vr_citta_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  Var_Citta = upper_string(get_testo(widget,"vr_citta"));
  gtk_entry_set_text (GTK_ENTRY(widget),Var_Citta);
    if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Var_Citta) {
                           if ( (isalpha(*Var_Citta) != 0))
                             {
                               if ( strcmp(Var_Citta,Citta_User) != 0 )
                               var_usave = lookup_widget(widget,"var_usave");
                               gtk_widget_set_sensitive(GTK_WIDGET(var_usave),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_vr_prov_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  Var_Prov = upper_string(get_testo(widget,"vr_prov"));
  gtk_entry_set_text (GTK_ENTRY(widget),Var_Prov);
   if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Var_Prov) {
                           if ( (isalpha(*Var_Prov) != 0))
                             {
                               if ( strcmp(Var_Prov,Prov_User) != 0 )
                               var_usave = lookup_widget(widget,"var_usave");
                               gtk_widget_set_sensitive(GTK_WIDGET(var_usave),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_vr_cap_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gint c;
  Var_Cap = get_testo(widget,"vr_cap");
  gtk_entry_set_text (GTK_ENTRY(widget),Var_Cap);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Var_Cap)
        { if ( (c = isalpha(*Var_Cap) != 0)) gdk_beep();
	  else { if ( strcmp(Var_Cap,Cap_User) != 0 )
                 var_usave = lookup_widget(widget,"var_usave");
                 gtk_widget_set_sensitive(GTK_WIDGET(var_usave),TRUE);
		}
         }
      else  gdk_beep();
     }

  return FALSE;
}


gboolean
on_vr_tel_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gint c;
  Var_Tel = get_testo(widget,"vr_tel");
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Var_Tel)
        { if ( (c = isalpha(*Var_Tel) != 0)) gdk_beep();
	  else { if ( strcmp(Var_Tel,Tel_User) != 0 )
                 var_usave = lookup_widget(widget,"var_usave");
                 gtk_widget_set_sensitive(GTK_WIDGET(var_usave),TRUE);
		}
         }
      else  gdk_beep();
     }

  return FALSE;
}


gboolean
on_vr_fax_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gint c;
  Var_Fax = get_testo(widget,"vr_fax");
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Var_Fax)
        { if ( (c = isalpha(*Var_Fax) != 0)) gdk_beep();
	  else { if ( strcmp(Var_Fax,Fax_User) != 0 )
                 var_usave = lookup_widget(widget,"var_usave");
                 gtk_widget_set_sensitive(GTK_WIDGET(var_usave),TRUE);
		}
         }
      else  gdk_beep();
     }

  return FALSE;
}


gboolean
on_vr_email_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  Var_Mail = get_testo(widget,"vr_email");
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Var_Mail) {
                           if ( (isalpha(*Var_Mail) != 0))
                             {
                               if ( strcmp(Var_Mail,Mail_User) != 0 )
                               var_usave = lookup_widget(widget,"var_usave");
                               gtk_widget_set_sensitive(GTK_WIDGET(var_usave),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_vr_ivavar_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gint c;
  Var_Iva = get_testo(widget,"vr_ivavar");
   if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*Var_Iva)
        { if ( (c = isalpha(*Var_Iva) != 0)) gdk_beep();
	  else { if ( strcmp(Var_Iva,Iva_User) != 0 )
                 var_usave = lookup_widget(widget,"var_usave");
                 gtk_widget_set_sensitive(GTK_WIDGET(var_usave),TRUE);
		}
         }
      else  gdk_beep();
     }

  return FALSE;
}


void
on_user_gsclose_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(ana_user);
  ghiaccia(deskbase,btt_desk_anagr,"btt_desk_anagr",1);
  ghiaccia(deskbase,tariffa,"tariffa",1);
}


void
on_var_usave_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[400];
  gchar *quantita,*prezzo;
  gint n_tuple;

  text_note_var = lookup_widget(ana_user,"text_note_var");

  vr_prz = lookup_widget(ana_user,"vr_prz");
  Var_Note = upper_string(gtk_editable_get_chars(GTK_EDITABLE(text_note_var),0,-1));
  Var_Nome = get_testo(ana_user,"vr_nmuser");
  Var_Ind = get_testo(ana_user,"vr_induser");
  Var_Citta = get_testo(ana_user,"vr_citta");
  Var_Prov = get_testo(ana_user,"vr_prov");
  Var_Cap = get_testo(ana_user,"vr_cap");
  Var_Tel = get_testo(ana_user,"vr_tel");
  Var_Fax = get_testo(ana_user,"vr_fax");
  Var_Mail = get_testo(ana_user,"vr_email");
  Var_Iva = get_testo(ana_user,"vr_ivavar");
  Var_Tipo_Contr = get_testo(ana_user,"vr_contr");
  Var_Gadget = get_testo(ana_user,"vr_gad");
  Var_Data = get_testo(ana_user,"vr_data");
  quantita = get_testo(ana_user,"vr_qt");
  prezzo = get_testo(ana_user,"vr_prz");

  sprintf(comando,"UPDATE utenti SET nome='%s',indirizzo='%s',citta='%s',prov='%s',\
	  cap='%s',tel='%s',fax='%s',email='%s',piva='%s',tipo_c='%s',gadget='%s',\
          qt='%s',euro='%s',lug='%s',data='%s',note='%s' WHERE id='%d';",Var_Nome,Var_Ind,Var_Citta,\
          Var_Prov,Var_Cap,Var_Tel,Var_Fax,Var_Mail,Var_Iva,Var_Tipo_Contr,Var_Gadget,\
          quantita,prezzo,Lug_User,Var_Data,Var_Note,ID);
  PQexec(connessione,comando);

  sprintf(comando,"SELECT nome,indirizzo,citta,prov,cap,tel,fax,email,\
          piva,tipo_c,gadget,qt,euro,data,note,id,lug\
          FROM utenti ORDER BY nome;");

  /* Variabile globale, la sfrutto per evitare un altra SELECT
   * nel select_child */
  Res_User = PQexec(connessione,comando);
  n_tuple = PQntuples(Res_User);
   if (n_tuple > 0) load_list(comando, ana_user, "list3"); 

  ghiaccia(ana_user,var_usave,"var_usave",0);
  gtk_entry_set_editable (GTK_ENTRY (vr_prz),FALSE);

  /* Aggiorna i totali */
  totali();
}


void
on_reload_user_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *comando;
  gint n_tuple;

  comando = strdup("SELECT nome,indirizzo,citta,prov,cap,tel,fax,email,\
                    piva,tipo_c,gadget,qt,euro,data,note,id,lug\
                    FROM utenti ORDER BY nome;");
  /* Variabile globale, la sfrutto per evitare un altra SELECT
   * nel select_child */
   Res_User = PQexec(connessione,comando);
   n_tuple = PQntuples(Res_User);

   List3_Items = n_tuple;

   if (n_tuple > 0) load_list(comando, ana_user, "list3"); 
   ghiaccia(ana_user,var_usave,"var_usave",0);
   vr_prz= lookup_widget(ana_user,"vr_prz");
   gtk_entry_set_editable (GTK_ENTRY (vr_prz),FALSE);
}


void
on_btt_user_cancel_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{ gdk_beep();
 user_cancel = create_user_cancel();
 gtk_widget_show(user_cancel);
}


gboolean
on_anagrafica_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  ghiaccia(deskbase,desk_gad,"desk_gad",1);
  return FALSE;
}


void
on_ana_note_switch_page                (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{ gchar *comando;
  int note_number, n_tuple;

  ana_note = lookup_widget(anagrafica,"ana_note");
  note_number = gtk_notebook_get_current_page(GTK_NOTEBOOK(ana_note));

  if ( note_number == 0 ) {
          var_save = lookup_widget(anagrafica,"var_save");
          gtk_widget_set_sensitive(GTK_WIDGET(var_save),FALSE);

          comando = strdup("SELECT * FROM gadget ORDER BY nome;");
          /* Variabile globale, la sfrutto per evitare un altra SELECT
           * nel select_child */
          Res_gad = PQexec(connessione,comando);
          n_tuple = PQntuples(Res_gad);
          if (n_tuple > 0) load_list(comando, anagrafica, "list4");
         }

}


gboolean
on_prodotto_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *prezzo;
  PRODOTTO = upper_string(get_testo(anagrafica,"prodotto"));
  gtk_entry_set_text (GTK_ENTRY(widget),PRODOTTO);

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
   { prezzo = lookup_widget(anagrafica,"prezzo");
     gtk_window_set_focus(GTK_WINDOW(anagrafica), prezzo);
   }

  return FALSE;
}


gboolean
on_prezzo_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ float prezzo;
  gchar *p_prezzo;
 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
   {
   /* Variabile globale, mi serve per inserire il prezzo
      quando il pulsanta salva  pemuto */

   PREZZO = get_testo(anagrafica,"prezzo");

  /* Cambiamo il segno separatore, per la conversione
     atof non accetta il punto */
  for (p_prezzo = PREZZO; *p_prezzo; p_prezzo++)
     if ( *p_prezzo == '.') *p_prezzo = ',';

  /* Converto il prezzo */
  prezzo = atof(PREZZO);
  /* Arrotondo e tronco alla II decimale */
  sprintf(PREZZO,"%.2f",prezzo);

    if (*PRODOTTO)
      if (prezzo >= 0)
        { 
          prd_save = lookup_widget(anagrafica,"prd_save");
          gtk_widget_set_sensitive(GTK_WIDGET(prd_save),TRUE);
        }
   }

  return FALSE;
}


void
on_prd_close_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gtk_widget_destroy(anagrafica);
  ghiaccia(deskbase,desk_gad,"desk_gad",1);
}


void
on_prd_save_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *p_prezzo;
  GtkWidget *prodotto;
  GtkWidget *prezzo;

 /* Inseriamo il prodotto nella tabella */
  gchar comando[200];
  /* Al contrario di atof, postgres non accetta la "," ma il punto */
  for (p_prezzo = PREZZO; *p_prezzo; p_prezzo++)
     if ( *p_prezzo == ',') *p_prezzo = '.';

  sprintf(comando,"INSERT INTO gadget (nome,euro) VALUES ('%s','%s');",PRODOTTO,PREZZO);
  PQexec(connessione,comando);

  prodotto = lookup_widget(anagrafica,"prodotto");
  prezzo = lookup_widget(anagrafica,"prezzo");

  gtk_entry_set_text (GTK_ENTRY (prodotto),"");
  gtk_window_set_focus(GTK_WINDOW(anagrafica),prodotto);
  gtk_entry_set_text (GTK_ENTRY (prezzo),"");

  ghiaccia(anagrafica,prd_save,"prd_save",0);

}


gboolean
on_anagr_find_entry_key_press_event    (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *percento="%";
  char *prodotto;
  gchar comando[200];
  int n_tuple;
  prodotto = upper_string(get_testo(widget, "anagr_find_entry"));

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*prodotto) {
        if ( (isalpha(*prodotto) != 0))
            { sprintf(comando,"SELECT * FROM gadget WHERE nome LIKE\
                      '%s%s%s' ORDER BY id;",percento,prodotto,percento);
              Res_gad = PQexec(connessione,comando);
              n_tuple = PQntuples(Res_gad);
              if (n_tuple > 0) load_list(comando, anagrafica, "list4");
            }
         else gdk_beep();
        }
     else  gdk_beep();
   }

  return FALSE;
}


void
on_list4_select_child                  (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{ GtkWidget *prd_var;
  GtkWidget *prezzo_var;
  gchar *stringa;
  gint selezione_4;
  stringa = (gchar *) gtk_object_get_data((list->selection)->data,\
                                           "Return_Value");
  /* Widget */
  prd_var = lookup_widget(anagrafica,"prd_var");
  prezzo_var = lookup_widget(anagrafica,"prezzo_var");

  selezione_4 = atoi(stringa);

  /* Valori */
  GADGET = strdup(PQgetvalue(Res_gad,selezione_4,0));
  PREZZO = strdup(PQgetvalue(Res_gad,selezione_4,1));

  /* Entry */
  gtk_entry_set_text (GTK_ENTRY (prd_var), GADGET);
  gtk_entry_set_text (GTK_ENTRY (prezzo_var), PREZZO);
  /* La variabile globale mi serve per la cancellazione del record */
  Record_gad = atoi(PQgetvalue(Res_gad,selezione_4,2));


  /* Questa funzione setta lo scrolling della lista */
  set_scrolled_window(anagrafica,"scrolledwindow52","list4");

}


gboolean
on_prd_var_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ 
  GADGET_VAR = upper_string(get_testo(widget,"prd_var"));
  gtk_entry_set_text (GTK_ENTRY(widget),GADGET_VAR);
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*GADGET_VAR) {
                           if ( (isalpha(*GADGET_VAR) != 0))
                             {
                               if ( strcmp(GADGET_VAR, GADGET) != 0 )
                               var_save = lookup_widget(widget,"var_save");
                               gtk_widget_set_sensitive(GTK_WIDGET(var_save),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}


gboolean
on_prezzo_var_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ 
  char *tmp;
  tmp = get_testo(widget, "prezzo_var");

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
      { if (*tmp) {
                   if ( (isalpha(*tmp) != 0)) gdk_beep();
                   else {
                         PREZZO_VAR = strdup(tmp);
                         if ( strcmp(PREZZO_VAR,PREZZO) != 0 )
                              var_save = lookup_widget(widget,"var_save");
                              gtk_widget_set_sensitive(GTK_WIDGET(var_save),TRUE);
                        }
                   }
                   else  gdk_beep();
                }

  return FALSE;
}


void
on_close_gst_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gtk_widget_destroy(anagrafica);
  ghiaccia(deskbase,desk_gad,"desk_gad",1);
}


void
on_var_save_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[200];
  gint n_tuple;

  if (!GADGET_VAR) GADGET_VAR = strdup(GADGET);
  if (!PREZZO_VAR) PREZZO_VAR = strdup(PREZZO);

  if (strcmp(GADGET,GADGET_VAR) != 0)
    sprintf(comando,"UPDATE gadget SET nome='%s' WHERE id='%d';",GADGET_VAR,Record_gad);

  if (strcmp(PREZZO,PREZZO_VAR) != 0)
    sprintf(comando,"UPDATE gadget SET euro='%s' WHERE id='%d';",PREZZO_VAR,Record_gad);

  PQexec(connessione,comando);

  ghiaccia(anagrafica,var_save,"var_save",0);
  sprintf(comando,"SELECT * FROM gadget ORDER BY id;");
  Res_gad = PQexec(connessione,comando);
  n_tuple = PQntuples(Res_gad);
  if (n_tuple > 0) load_list(comando, anagrafica, "list4");
}


void
on_reload_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{ 
  gchar *comando;
  gint n_tuple;
  ghiaccia(anagrafica,var_save,"var_save",0);
  comando = strdup("SELECT * FROM gadget ORDER BY id;");
  Res_gad = PQexec(connessione,comando);
  n_tuple = PQntuples(Res_gad);
  if (n_tuple > 0) load_list(comando, anagrafica, "list4");
}


void
on_del_btt_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ 
  prd_cancel = create_prd_cancel();
  gtk_widget_show(prd_cancel);
  gdk_beep();
}


void
on_prd_cancel_no_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
 prd_cancel = lookup_widget(prd_cancel,"prd_cancel");
 gtk_widget_destroy(prd_cancel);
}


void
on_prd_cancel_si_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[100];
  GtkWidget *prd_var;
  GtkWidget *prezzo_var;

  prd_var = lookup_widget(anagrafica,"prd_var");
  prezzo_var = lookup_widget(anagrafica,"prezzo_var");
  gtk_entry_set_text (GTK_ENTRY (prd_var),"");
  gtk_entry_set_text (GTK_ENTRY (prezzo_var),"");

  prd_cancel = lookup_widget(prd_cancel,"prd_cancel");
  sprintf(comando,"DELETE FROM gadget WHERE id='%d';",Record_gad);
  PQexec(connessione,comando);
  sprintf(comando,"SELECT * FROM gadget ORDER BY id;");
  Res_gad = PQexec(connessione,comando);

  load_list(comando, anagrafica, "list4");
  gtk_widget_destroy(prd_cancel);
}


void
on_user_nodel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(user_cancel);
}


void
on_user_sidel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *comando = NULL;
  gchar buf[200];
  sprintf(buf,"DELETE FROM utenti WHERE id='%d';",ID);
  PQexec(connessione,buf);
  gtk_widget_destroy(user_cancel);

  comando = strdup("SELECT nome,indirizzo,citta,prov,cap,tel,fax,email,\
                    piva,tipo_c,gadget,qt,euro,data,note,id,lug\
                    FROM utenti ORDER BY nome;");
  /* Variabile globale, la sfrutto per evitare un altra SELECT
   * nel select_child */
   Res_User = PQexec(connessione,comando);

   Nome_User = NULL;
   Ind_User = NULL;
   Citta_User = NULL;
   Prov_User = NULL;
   Cap_User = NULL;
   Tel_User = NULL;
   Fax_User = NULL;
   Mail_User = NULL;
   Iva_User = NULL;
   Tipo_Contr = NULL;
   Gadget = NULL;
   Note_User = NULL;

   /* Pulisco tutti i campi */
   clear_vuser();

   /* Ricarico la lista */
   load_list(comando, ana_user, "list3");
}


void
on_coll_nodel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(coll_cancel);
}


void
on_coll_sidel_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[200];
  GtkWidget *contr_var;
  GtkWidget *entry_cassa;
  GtkWidget *entry_gad;

  contr_var = lookup_widget(collaborazioni,"contr_var");
  entry_cassa = lookup_widget(collaborazioni,"entry_cassa");
  entry_gad = lookup_widget(collaborazioni,"entry_gad");

  sprintf(comando,"DELETE FROM tipologie WHERE id='%d';",Record_tipol);
  PQexec(connessione,comando);
  sprintf(comando,"SELECT * FROM tipologie ORDER BY id;");
  Res_tipol = PQexec(connessione,comando);

  
  gtk_entry_set_text (GTK_ENTRY (contr_var),"");
  gtk_entry_set_text (GTK_ENTRY (entry_cassa),"");
  gtk_entry_set_text (GTK_ENTRY (entry_gad),"");

  load_list(comando, collaborazioni, "list5");
  gtk_widget_destroy(coll_cancel);
}


void
on_okbtt_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{ PQfinish(connessione);
  gtk_widget_destroy(deskbase);
  gtk_exit(0);
}


void
on_info_btt_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ PQfinish(connessione);
  gtk_widget_destroy(deskbase);
  gtk_exit(0);
}


void
on_exit_n_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(exit_yn);
}


void
on_exit_y_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{ PQfinish(connessione);
  gtk_widget_destroy(deskbase);
  gtk_exit(0);
}


gboolean
on_database_delete_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  ghiaccia(deskbase,open_data,"open_data",1);
  return FALSE;
}


void
on_radio_export_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{ data_btt_conf = lookup_widget(database,"data_btt_conf");
  gtk_window_set_focus(GTK_WINDOW(database), data_btt_conf);
  data_button_sel = lookup_widget(database,"data_button_sel");
  data_btt_conf = lookup_widget(database,"data_btt_conf");
  gtk_widget_set_sensitive(GTK_WIDGET(data_button_sel),FALSE);
  gtk_widget_set_sensitive(GTK_WIDGET(data_btt_conf),TRUE);
}


void
on_radio_import_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{ data_button_sel = lookup_widget(database,"data_button_sel");
  data_btt_conf = lookup_widget(database,"data_btt_conf");
  gtk_widget_set_sensitive(GTK_WIDGET(data_button_sel),TRUE);
  gtk_widget_set_sensitive(GTK_WIDGET(data_btt_conf),FALSE);
}


void
on_data_button_sel_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{ files_selection = create_files_selection();
  gtk_widget_show(files_selection);
}


void
on_data_btt_conf_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{ iedata = create_iedata();
  gtk_widget_show(iedata);
  gdk_beep();
}


void
on_data_btt_annulla_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(database);
 ghiaccia(deskbase,open_data,"open_data",1);
}


void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{ gchar buf[200], suffisso[3];
  gchar *p_buf;
  gint  i, x;
  GtkWidget *p_eti;

  Testo = strdup(gtk_file_selection_get_filename(GTK_FILE_SELECTION (files_selection) ));

  strcpy(buf,Testo);

  /* contiamo i caratteri */
  for (p_buf = buf, i = 0; *p_buf; p_buf++, i++)
          ;
  /* Isoliamo il suffisso */
  for ( x = 0, i -= 3; x < 3; x++ )
         suffisso[x] = buf[i++];
  suffisso[3] = '\0';

  Suffisso = strdup(suffisso);

  if ( strcmp(suffisso,"sql") == 0 )
     {  gtk_widget_destroy(files_selection);
        gtk_widget_destroy(database);
        db_info = create_db_info();
        gtk_widget_show(db_info);
        gdk_beep();
      }
  else if ( strcmp(suffisso,"bku") == 0 )
       { gtk_widget_destroy(files_selection);
           gtk_widget_destroy(database);
           db_info = create_db_info();
           gtk_widget_show(db_info);
           gdk_beep();
          }
        else if ( strcmp(suffisso,"usr") == 0 )
               { gtk_widget_destroy(files_selection);
                 gtk_widget_destroy(database);
                 db_info = create_db_info();
                 gtk_widget_show(db_info);
                 gdk_beep();
               }
               else if ( strcmp(suffisso,"usr") == 0 )
                     { gtk_widget_destroy(files_selection);
                       gtk_widget_destroy(database);
                       db_info = create_db_info();
                       gtk_widget_show(db_info);
                       gdk_beep();
                     }
                     else { info = create_info();
                            /* Cambiamo etichetta alla info */
                            p_eti = lookup_widget(info, "info_label");
                            gtk_label_set(GTK_LABEL(p_eti), "File Non Valido");
                            gdk_beep();
                            gtk_widget_show(info);
                          }
}


void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(files_selection);
}


void
on_ie_cancel_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(iedata);
}


void
on_ie_conf_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[200];
  GtkWidget *p_eti;
  gchar *combosel;

  combosel = get_testo(database,"sql_entry");

  if (strcmp(combosel,"Tutto il Database") == 0 )
        { sprintf(comando,"pg_dump -a -Ft gtklin -f /tmp/gtklin.sql");
          system(comando);

          info = create_info();
          /* Cambiamo etichetta alla info */
          p_eti = lookup_widget(info, "info_label");
          gtk_label_set(GTK_LABEL(p_eti), "gtklin.sql  stato salvato in /tmp");
        }

  else { sprintf(comando,"pg_dump -a -Ft -t utenti -d gtklin -f /tmp/gtklin.usr");
         system(comando);

         info = create_info();
         /* Cambiamo etichetta alla info */
         p_eti = lookup_widget(info, "info_label");
         gtk_label_set(GTK_LABEL(p_eti), "gtklin.usr  stato salvato in /tmp");
        }

  gdk_beep();
  gtk_widget_show(info);

  gtk_widget_destroy(iedata);
  gtk_widget_destroy(database);
  ghiaccia(deskbase,open_data,"open_data",1);
}


void
on_db_ok_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{ gint i, err;
  GtkWidget *p_eti;
  gchar comando[200];
  gchar *campi_clear[] = { "utenti", "tipologie", "gadget" };

  /* Se ho selezionato gli utenti faccio il backup e li  carico */
  if (strcmp(Suffisso,"usr") == 0 )
    { err = system("test -s /tmp/gtklin.bku");
      if (!err) { overwrite = create_overwrite();
                  gtk_widget_destroy(db_info);
                  gtk_widget_show(overwrite);
                 }
      else { sprintf(comando,"pg_dump -a -Ft -t utenti -d gtklin -f /tmp/gtklin.bku");
             system(comando);
             sprintf(comando,"DELETE FROM utenti");
             PQexec(connessione,comando);
             sprintf(comando,"pg_restore -a -S postgres -Ft -t utenti -d gtklin %s",Testo );
             //sprintf(comando,"pg_restore -a -Ft -t utenti %s| psql -U postgres -d gtklin",Testo );
             system(comando);
             gtk_widget_destroy(db_info);
             info = create_info();
             p_eti = lookup_widget(info, "info_label");
             gtk_label_set(GTK_LABEL(p_eti), "... Fatto!");
             gdk_beep();
             gtk_widget_show(info);
           }
     }
   else {
        /* Se ho selezionato il backup faccio direttamente il restore */
        if (strcmp(Suffisso,"bku") == 0 )
          { for ( i = 0; i < 15; i++ )
              { sprintf(comando,"DELETE FROM %s",campi_clear[i]);
                PQexec(connessione,comando);
              }
            mio_restore();
            gtk_widget_destroy(db_info);
           }

        else  /* Se esiste il backup chiedo se voglio sovrascrivere */
            { err = system("test -s /tmp/gtklin.bku");
              if (!err) { overwrite = create_overwrite();
                          gtk_widget_destroy(db_info);
                          gtk_widget_show(overwrite);
                          gdk_beep();
                        }
              else /* Altrimenti creo il backup */
                   { sprintf(comando,"pg_dump -a -Ft gtklin -f /tmp/gtklin.bku");
                     system(comando);
                     for ( i = 0; i < 15; i++ )
                        { sprintf(comando,"DELETE FROM %s",campi_clear[i]);
                          PQexec(connessione,comando);
                         }
                     mio_restore();
                     gtk_widget_destroy(db_info);
                    }
            }
        }
  ghiaccia(deskbase,open_data,"open_data",1);
}


void
on_db_no_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(db_info);
  ghiaccia(deskbase,open_data,"open_data",1);
}


void
on_over_no_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(overwrite);
}


void
on_over_si_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[100];
  GtkWidget *p_eti;

  if ( strcmp(Suffisso,"usr") == 0)
    { system("mv /tmp/gtklin.bku /tmp/gtklin.org");
      sprintf(comando,"pg_dump -a -Ft -t utenti -d gtklin -f /tmp/gtklin.bku");
      system(comando);
      sprintf(comando,"DELETE FROM utenti");
      PQexec(connessione,comando);
      //sprintf(comando,"pg_restore -a -Ft -t utenti %s| psql -U postgres -d gtklin",Testo );
      sprintf(comando,"pg_restore -a -S postgres -Ft -t utenti -d gtklin %s",Testo );
      system(comando);
      gtk_widget_destroy(overwrite);
      info = create_info();
      gtk_widget_show(info);
      p_eti = lookup_widget(info, "info_label");
      gtk_label_set(GTK_LABEL(p_eti), "... Fatto!");
      gdk_beep();
      gtk_widget_show(info);
    }
    else if ( strcmp(Suffisso,"bku") == 0)
           { system(comando);
             sprintf(comando,"DELETE FROM utenti");
             PQexec(connessione,comando);
             //sprintf(comando,"pg_restore -a -Ft -t utenti %s| psql -U postgres -d gtklin ",Testo );
             sprintf(comando,"pg_restore -a -S postgres -Ft -t utenti -d gtklin %s",Testo );
             system(comando);
             gtk_widget_destroy(overwrite);
             info = create_info();
             gtk_widget_show(info);
             p_eti = lookup_widget(info, "info_label");
             gtk_label_set(GTK_LABEL(p_eti), "... Fatto!");
             gdk_beep();
             gtk_widget_show(info);
            }

          else { sprintf(comando,"pg_dump -a -Ft gtklin -f /tmp/gtklin.bku");
                 system(comando);
                 gtk_widget_destroy(overwrite);
                 mio_restore();
                }
}


void
on_lp_annulla_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(stamp);
}


void
on_lp_conferma_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{ PGresult *res;
  gchar comando[250];
  gchar *device;
  gchar *tipo;
  gint n_tuple, n_copie;

  tipo = get_testo(stamp,"combo_entry5");
  device = get_testo(stamp,"combo_entry6");
  n_copie = atoi(get_testo(stamp,"spinbutton1"));

   if (strcmp(tipo,"Riepilogo") == 0)
     { sprintf(comando,"SELECT nome,indirizzo,email,tipo_c,euro FROM utenti ORDER BY nome;");
       res = PQexec(connessione,comando);
       n_tuple = PQntuples(res);
       if (n_tuple > 0)
         { print_riepilogo(n_tuple,res,tipo,device,n_copie);
           gtk_widget_destroy(stamp);
         }
         else { info = create_info();
                gdk_beep();
                info_label = lookup_widget(info,"info_label");
                gtk_label_set(GTK_LABEL(info_label),"Nessun Prodotto Nei Dati Selezionati");
                gtk_widget_show(info);
              }
      }
   else { sprintf(comando,"SELECT nome,indirizzo,citta,email,tel FROM utenti ORDER BY nome;");
          res = PQexec(connessione,comando);
          n_tuple = PQntuples(res);
          if (n_tuple > 0)
            { print_anagrafica(n_tuple,res,tipo,device,n_copie);
              gtk_widget_destroy(stamp);
            }
            else { info = create_info();
                   gdk_beep();
                   info_label = lookup_widget(info,"info_label");
                   gtk_label_set(GTK_LABEL(info_label),"Nessun Prodotto Nei Dati Selezionati");
                   gtk_widget_show(info);
                 }
        }
   }

void
on_button_exit_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(lc_view);
}


void
on_no_conn_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(db_conn);
}


void
on_yes_conn_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{  FILE *f;
   int RECORD;
   gchar *database;
   database =  get_testo(db_conn, "entry_conn");
   RECORD = 20;
   f=fopen("./memodb.gtl", "w");
   fwrite(database,1,RECORD,f);
   gtk_widget_destroy(db_conn);

   info = create_info();
   info_label = lookup_widget(info, "info_label");
   gtk_label_set(GTK_LABEL(info_label), "Chiudere GtkLin e riavviare");
   gdk_beep();
   gtk_widget_show(info);
}


void
on_check_cassa_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{ check_cassa = lookup_widget(collaborazioni,"check_cassa");
  check_gadget = lookup_widget(collaborazioni,"check_gadget");
  check_lug = lookup_widget(collaborazioni,"check_lug");

  if ( GTK_TOGGLE_BUTTON (check_cassa)->active)
    MOV_CASSA = strdup("SI");
    else MOV_CASSA = strdup("NO");

  if ( GTK_TOGGLE_BUTTON (check_lug)->active)
    MOV_LUG = strdup("SI");
    else MOV_LUG = strdup("NO");

  if ( GTK_TOGGLE_BUTTON (check_gadget)->active)
    COME_GAD = strdup("SI");
    else COME_GAD = strdup("NO");
}


void
on_check_gadget_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)

{ check_cassa = lookup_widget(collaborazioni,"check_cassa");
  check_gadget = lookup_widget(collaborazioni,"check_gadget");
  check_lug = lookup_widget(collaborazioni,"check_lug");

  if ( GTK_TOGGLE_BUTTON (check_cassa)->active)
    MOV_CASSA = strdup("SI");
    else MOV_CASSA = strdup("NO");

  if ( GTK_TOGGLE_BUTTON (check_lug)->active)
    MOV_LUG = strdup("SI");
    else MOV_LUG = strdup("NO");

  if ( GTK_TOGGLE_BUTTON (check_gadget)->active)
    COME_GAD = strdup("SI");
    else COME_GAD = strdup("NO");
}


void
on_btt_si_contr_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{ 
  /* Se anche le altre variabili sono state settate
   * posso salvare */
        if (Nome_User)
          if (Ind_User)
            if (Citta_User)
              if (Prov_User)
                if (Cap_User)
                  if (Tel_User)
                    { if (Mail_User) 
                        { ana_conf = create_ana_conf();
                          gtk_widget_show(ana_conf);
			  if (!Gadget) Gadget = strdup("Nessuno");
			  if (!Gd_Prz) Gadget = strdup("0");
			  totali();
                        } 
                      else label_show("text");
                    }
               else label_show("Anagrafica Incompleta");
            else label_show("Anagrafica Incompleta");
          else label_show("Anagrafica Incompleta");
        else label_show("Anagrafica Incompleta");
      else label_show("Anagrafica Incompleta");
    else label_show("Anagrafica Incompleta");
}


void
on_btt_no_contr_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{ gtk_widget_destroy(Contribuzione);
  /* Se anche le altre variabili sono state settate
   * posso salvare */
   if (Nome_User)
    if (Ind_User)
     if (Citta_User)
      if (Prov_User)
       if (Cap_User)
        if (Tel_User)
         if (Mail_User)
            ghiaccia(ana_user,user_save,"user_save",1);
}


gboolean
on_tipo_contr_key_press_event          (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ TIPOLOGIA = upper_string(get_testo(collaborazioni,"tipo_contr"));
  gtk_entry_set_text (GTK_ENTRY(widget),TIPOLOGIA);

 if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
   { check_cassa = lookup_widget(collaborazioni,"check_cassa");
     check_gadget = lookup_widget(collaborazioni,"check_gadget");

     if ( GTK_TOGGLE_BUTTON (check_cassa)->active)
       MOV_CASSA = strdup("SI");
       else MOV_CASSA = strdup("NO");

     if ( GTK_TOGGLE_BUTTON (check_gadget)->active)
       COME_GAD = strdup("SI");
       else COME_GAD = strdup("NO");

     if (*TIPOLOGIA)
     ghiaccia(collaborazioni,save_tipo,"save_tipo",1);
   }

  return FALSE;
}


void
on_save_tipo_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ GtkWidget *tipo_contr;
  tipo_contr = lookup_widget(collaborazioni,"tipo_contr");
  gchar comando[300];
 sprintf(comando,"INSERT INTO tipologie (nome,cassa,gadget,lug)\
 VALUES ('%s','%s','%s','%s');",TIPOLOGIA,MOV_CASSA,COME_GAD,MOV_LUG);
 PQexec(connessione,comando);
 gtk_entry_set_text (GTK_ENTRY (tipo_contr),"");
 ghiaccia(collaborazioni,save_tipo,"save_tipo",0);
 gtk_window_set_focus(GTK_WINDOW(collaborazioni),tipo_contr);
}


void
on_coll_close_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(collaborazioni);
  ghiaccia(deskbase,btt_desk_col,"btt_desk_col",1);
}


void
on_note_coll_switch_page               (GtkNotebook     *notebook,
                                        GtkNotebookPage *page,
                                        gint             page_num,
                                        gpointer         user_data)
{ GtkWidget *note_coll;
  gchar *comando;
  int note_number, n_tuple;

  note_coll = lookup_widget(collaborazioni,"note_coll");
  note_number = gtk_notebook_get_current_page(GTK_NOTEBOOK(note_coll));

  if ( note_number == 0 ) {
          /* Variabile globale, la sfrutto per evitare un altra SELECT
           * nel select_child */
          //ghiaccia(collaborazioni,butt_cl_varsv,"butt_cl_varsv",0);
          comando = strdup("SELECT * FROM tipologie ORDER BY id;");
          Res_tipol = PQexec(connessione,comando);
          n_tuple = PQntuples(Res_tipol);
          if (n_tuple > 0) load_list(comando, collaborazioni, "list5");
         }

}


void
on_butt_cl_varsv_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[250];
  gint n_tuple;
 
  TIPOLOGIA_VAR = upper_string(get_testo(collaborazioni,"contr_var"));

  if (TIPOLOGIA && TIPOLOGIA_VAR)
   { if (strcmp(TIPOLOGIA,TIPOLOGIA_VAR) != 0)
      { sprintf(comando,"UPDATE tipologie SET nome='%s' WHERE id='%d';",\
        TIPOLOGIA_VAR,Record_tipol);
        PQexec(connessione,comando);
      }

       sprintf(comando,"UPDATE tipologie SET cassa='%s', gadget='%s', lug='%s'\
               WHERE id='%d';",MOV_CASSA,COME_GAD,MOV_LUG,Record_tipol);
       PQexec(connessione,comando);

       sprintf(comando,"SELECT * FROM tipologie ORDER BY id;");
       Res_tipol = PQexec(connessione,comando);
       n_tuple = PQntuples(Res_tipol);
       if (n_tuple > 0) load_list(comando, collaborazioni, "list5");
   }
}


void
on_list5_select_child                  (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{ GtkWidget *entry_cassa;
  GtkWidget *entry_gad;
  GtkWidget *entry_lug;
  GtkWidget *contr_var;
  GtkWidget *check_varcassa;
  GtkWidget *check_vargad;
  GtkWidget *check_varlug;
  gchar *stringa;
  gint selezione_5;
  stringa = (gchar *) gtk_object_get_data((list->selection)->data,\
                                           "Return_Value");
  /* Widget */
  check_varcassa = lookup_widget(collaborazioni,"check_varcassa");
  check_vargad = lookup_widget(collaborazioni,"check_vargad");
  check_varlug = lookup_widget(collaborazioni,"check_varlug");
  contr_var = lookup_widget(collaborazioni,"contr_var");
  entry_cassa = lookup_widget(collaborazioni,"entry_cassa");
  entry_gad = lookup_widget(collaborazioni,"entry_gad");
  entry_lug = lookup_widget(collaborazioni,"entry_lug");

  selezione_5 = atoi(stringa);

  /* Valori */
  TIPOLOGIA = strdup(PQgetvalue(Res_tipol,selezione_5,0));
  MOV_CASSA = strdup(PQgetvalue(Res_tipol,selezione_5,1));
  COME_GAD = strdup(PQgetvalue(Res_tipol,selezione_5,2));
  MOV_LUG = strdup(PQgetvalue(Res_tipol,selezione_5,3));


  /* Set_Toggle */
  if (strcmp(MOV_CASSA,"SI") == 0)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_varcassa),TRUE);
  else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_varcassa),FALSE);

  if (strcmp(COME_GAD,"SI") == 0)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_vargad),TRUE);
  else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_vargad),FALSE);

  if (strcmp(MOV_LUG,"SI") == 0)
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_varlug),TRUE);
  else gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(check_varlug),FALSE);

  /* Entry */
  gtk_entry_set_text (GTK_ENTRY (contr_var), TIPOLOGIA);
  gtk_entry_set_text (GTK_ENTRY (entry_cassa), MOV_CASSA);
  gtk_entry_set_text (GTK_ENTRY (entry_gad), COME_GAD);
  gtk_entry_set_text (GTK_ENTRY (entry_lug), MOV_LUG);

  /* La variabile globale mi serve per la cancellazione del record */
  Record_tipol = atoi(PQgetvalue(Res_tipol,selezione_5,4));


  /* Questa funzione setta lo scrolling della lista */
  set_scrolled_window(collaborazioni,"scrolledwindow62","list5");
}


void
on_btt_col_reload_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *comando;
  gint n_tuple;
  //ghiaccia(collaborazioni,butt_cl_varsv,"butt_cl_varsv",0);
  comando = strdup("SELECT * FROM tipologie ORDER BY id;");
  Res_tipol = PQexec(connessione,comando);
  n_tuple = PQntuples(Res_tipol);
  if (n_tuple > 0) load_list(comando,collaborazioni,"list5");
}


void
on_coll_var_close_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(collaborazioni);
 ghiaccia(deskbase,btt_desk_col,"btt_desk_col",1);
}


void
on_check_varcassa_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
 { GtkWidget *check_varcassa;
  /* Lookup */
  check_varcassa = lookup_widget(collaborazioni,"check_varcassa");
  entry_cassa = lookup_widget(collaborazioni,"entry_cassa");

  if ( GTK_TOGGLE_BUTTON (check_varcassa)->active)
    { gtk_entry_set_text (GTK_ENTRY(entry_cassa), "SI");
      MOV_CASSA  = strdup("SI");
     }
  else { gtk_entry_set_text (GTK_ENTRY(entry_cassa), "NO");
         MOV_CASSA  = strdup("NO");
       }
}


void
on_check_vargad_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
 { GtkWidget *check_vargad;
  /* Lookup */
  check_vargad = lookup_widget(collaborazioni,"check_vargad");
  entry_gad = lookup_widget(collaborazioni,"entry_gad");

  if ( GTK_TOGGLE_BUTTON (check_vargad)->active)
    { gtk_entry_set_text (GTK_ENTRY(entry_gad), "SI");
      COME_GAD  = strdup("SI");
     }
  else { gtk_entry_set_text (GTK_ENTRY(entry_gad), "NO");
         COME_GAD  = strdup("NO");
       }
}


void
on_coll_del_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ coll_cancel = create_coll_cancel();
  gtk_widget_show(coll_cancel);
  gdk_beep();
}


gboolean
on_coll_search_key_press_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *percento="%";
  char *prodotto;
  gchar comando[200];
  int c,n_tuple;
  prodotto = upper_string(get_testo(widget, "coll_search"));

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { if (*prodotto) {
        if ( (c = isalpha(*prodotto) != 0))
            { sprintf(comando,"SELECT * FROM tipologie WHERE nome LIKE\
                      '%s%s%s' ORDER BY id;",percento,prodotto,percento);
              Res_gad = PQexec(connessione,comando);
              n_tuple = PQntuples(Res_gad);
              if (n_tuple > 0) load_list(comando, collaborazioni, "list5");
            }
         else gdk_beep();
        }
     else  gdk_beep();
   }

  return FALSE;
}


gboolean
on_collaborazioni_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  ghiaccia(deskbase,btt_desk_col,"btt_desk_col",1);
  return FALSE;
}

gboolean
on_ind_user_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *citta;
  Ind_User = upper_string(get_testo(widget, "ind_user"));
  gtk_entry_set_text (GTK_ENTRY(widget),Ind_User);

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*Nome_User) {
                           if ( (isalpha(*Nome_User) != 0))
                             {
                               citta = lookup_widget(ana_user,"citta");
                               gtk_window_set_focus(GTK_WINDOW(ana_user), citta);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
                        }

  return FALSE;
}

gboolean
on_vr_qt_key_press_event               (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ PGresult *res;
  gchar euro[10];
  gchar comando[200];
  gchar *nome;
  gint n_tuple;
  gfloat unitario, totale;
  gchar *p_prezzo;

  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { /* Quantita inserita */
      vr_qt = lookup_widget(ana_user,"vr_qt");
      Var_Gad_Qt = atoi(get_testo(ana_user,"vr_qt"));
      var_usave = lookup_widget(ana_user,"var_usave");

      if (Gad_Qt != Var_Gad_Qt)
        ghiaccia(ana_user,var_usave,"var_usave",1);

      /* Prezzo unitario */
      nome = get_testo(ana_user,"vr_gad");
      sprintf(comando,"SELECT euro FROM gadget WHERE nome='%s'",nome);
      res = PQexec(connessione,comando);
      n_tuple = PQntuples(res);
      if (n_tuple > 0)
        { sprintf(euro,"%s",PQgetvalue(res, 0,0));
          /* Cambio il segno per il float */
          for ( p_prezzo = euro;*p_prezzo;p_prezzo++)
             if (*p_prezzo == '.') *p_prezzo = ',';
          /* Conversione */
          unitario = atof(euro);
          /* Il prezzo totale  uguale a quello unitario X la quantit */
          totale = unitario * Var_Gad_Qt;

          /* Ricopio il totale si euro e rimetto il separatore "." per il DB */
          sprintf(euro,"%.2f",totale);
          for ( p_prezzo = euro;*p_prezzo;p_prezzo++)
            if (*p_prezzo == ',') *p_prezzo = '.';

          vr_prz = lookup_widget(ana_user,"vr_prz");
          gtk_entry_set_text (GTK_ENTRY (vr_prz),euro);
        }
    }

  return FALSE;
}


gboolean
on_vr_prz_key_press_event              (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ gchar *p_var;
  sprintf(Var_Gd_Prz,"%s",get_testo(widget,"vr_prz"));
  
  for (p_var = Var_Gd_Prz; *p_var; *p_var++)
     if (*p_var == ',') *p_var = '.';
  
  if (strcmp(Var_Gd_Prz,Gd_Prz) != 0)
    ghiaccia(ana_user,var_usave,"var_usave",1);
  else
    ghiaccia(ana_user,var_usave,"var_usave",0);

  return FALSE;
}


gboolean
on_text_note_var_key_press_event       (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
  Var_Note = upper_string(gtk_editable_get_chars(GTK_EDITABLE(widget),0,-1));
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    {  if (strcmp(Note_User,Var_Note) != 0)
          { var_usave = lookup_widget(ana_user,"var_usave");
            ghiaccia(ana_user,var_usave,"var_usave",1);
          }
    }

  return FALSE;
}


void
on_user_save_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[400];
   /* Lo switch page setta le variabili per il confronto
   * dunque al ritorno saltano i settaggi precedenti e va fatta
   * la lettura di tutti i campi*/
  note_text = lookup_widget(ana_user,"note_text");
  Nome_User = get_testo(ana_user,"nm_user");
  Ind_User = get_testo(ana_user,"ind_user");
  Citta_User = get_testo(ana_user,"citta");
  Prov_User = get_testo(ana_user,"prov");
  Cap_User = get_testo(ana_user,"cap");
  Tel_User = get_testo(ana_user,"tel");
  Fax_User = get_testo(ana_user,"fax");
  Mail_User = get_testo(ana_user,"email");
  Iva_User = get_testo(ana_user,"piva");
  Note_User = upper_string(gtk_editable_get_chars(GTK_EDITABLE(note_text),0,-1));
  /* Evitiamo di inserire i null */
  if (!Fax_User) Fax_User = strdup("Nessuno");
  if (!Mail_User) Mail_User = strdup("Nessuna");
  if (!Fax_User) Fax_User = strdup("Nessuno");
  if (!Note_User) Note_User = strdup("Nessuna");
  Gadget = strdup("Nessuno");
  Tipo_Contr = strdup("Nessuno");
  Lug_User = strdup("NO");
  Gad_Qt = 0;
  sprintf(Gd_Prz,"0");
  
  sprintf(comando,"INSERT INTO utenti (nome,indirizzo,citta,prov,cap,tel,fax,\
	  email,piva,note,data,tipo_c,gadget,qt,euro,lug) VALUES ('%s','%s','%s','%s',\
          '%s','%s','%s','%s','%s','%s','%s','%s','%s','%d','%s','%s');",Nome_User,\
	  Ind_User,Citta_User,Prov_User,Cap_User,Tel_User,Fax_User,Mail_User,\
	  Iva_User,Note_User,DATA,Tipo_Contr,Gadget,Gad_Qt,Gd_Prz,Lug_User);
  PQexec(connessione,comando);
  clear_user();

  ghiaccia(ana_user,user_save,"user_save",0);
}

gboolean
on_note_text_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ 
  Note_User = upper_string(gtk_editable_get_chars(GTK_EDITABLE(widget),0,-1));
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
   if (! *Note_User) gdk_beep();

  return FALSE;
}

gboolean
on_Contribuzione_delete_event          (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{ gtk_widget_destroy(Contribuzione);
  ghiaccia(ana_user,user_save,"user_save",1);

  return FALSE;
}


void
on_combo_tipo_changed                  (GtkEditable     *editable,
                                        gpointer         user_data)
{ GtkWidget *combo_gad;
  GtkWidget *combo24;
  GtkWidget *entry_euro;
  GtkWidget *entry_qt;
  gchar *elemento, *cassa, *gadget;
  gchar comando[200];
  gint n_tuple;

  combo_gad = lookup_widget(Contribuzione,"combo_gad");
  combo24 = lookup_widget(Contribuzione,"combo24");
  entry_euro = lookup_widget(Contribuzione,"entry_euro");
  entry_qt = lookup_widget(Contribuzione,"entry_qt");

  elemento = get_testo(Contribuzione,"combo_tipo");
  sprintf(comando,"SELECT cassa,gadget,lug FROM tipologie WHERE\
  nome='%s' ORDER BY nome;",elemento);
  
  Res_combo_tipo = PQexec(connessione,comando);
  n_tuple = PQntuples(Res_combo_tipo);
  if (n_tuple > 0)
    { cassa = PQgetvalue(Res_combo_tipo, 0,0);
      gadget = PQgetvalue(Res_combo_tipo, 0,1);
      Lug_User = PQgetvalue(Res_combo_tipo, 0,2);

      if (strcmp(cassa,"NO") == 0 )
        { ghiaccia(Contribuzione,entry_euro,"entry_euro",0);
          ghiaccia(Contribuzione,entry_qt,"entry_qt",0);
        }
      else
        { ghiaccia(Contribuzione,entry_euro,"entry_euro",1);
          ghiaccia(Contribuzione,entry_qt,"entry_qt",1);
        }

      if (strcmp(gadget,"NO") == 0 )
        { ghiaccia(Contribuzione,combo_gad,"combo_gad",0);
          ghiaccia(Contribuzione,combo24,"combo24",0);
        }
      else
        { ghiaccia(Contribuzione,combo_gad,"combo_gad",1);
          ghiaccia(Contribuzione,combo24,"combo24",1);
        }

      if (strcmp(gadget,"NO") == 0 && strcmp(cassa,"SI") == 0)
        { ghiaccia(Contribuzione,combo_gad,"combo_gad",0);
          ghiaccia(Contribuzione,combo24,"combo24",0);
          ghiaccia(Contribuzione,entry_euro,"entry_euro",1);
          ghiaccia(Contribuzione,entry_qt,"entry_qt",0);
        }
    }

}


void
on_combo_gad_changed                   (GtkEditable     *editable,
                                        gpointer         user_data)
{ GtkWidget *entry_euro;
  gchar comando[200];
  gint n_tuple;
  gchar *p_prezzo;

  Gadget = get_testo(Contribuzione,"combo_gad");
  entry_euro = lookup_widget(Contribuzione,"entry_euro");

  sprintf(comando,"SELECT euro FROM gadget WHERE\
  nome='%s' ORDER BY nome;",Gadget);
  
  Res_combo_gad = PQexec(connessione,comando);
  n_tuple = PQntuples(Res_combo_gad);
  if (n_tuple > 0)
    { sprintf(Gd_Prz,"%s", PQgetvalue(Res_combo_gad, 0,0));

      for ( p_prezzo = Gd_Prz;*p_prezzo;p_prezzo++)
         if (*p_prezzo == '.') *p_prezzo = ',';

      Gad_Prz = atof(Gd_Prz);
      Unit_Prz = Gad_Prz;

      sprintf(Gd_Prz,"%.2f",Gad_Prz);

      for ( p_prezzo = Gd_Prz;*p_prezzo;p_prezzo++)
         if (*p_prezzo == ',') *p_prezzo = '.';

      gtk_entry_set_text (GTK_ENTRY (entry_euro),Gd_Prz);
    }

}


gboolean
on_entry_qt_key_press_event            (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *entry_euro;
  gchar *p_prezzo;
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
    { Gad_Qt = atoi(get_testo(Contribuzione,"entry_qt"));
      entry_euro = lookup_widget(Contribuzione,"entry_euro");
      if (Gad_Qt == 0) Gad_Qt = 1;
      Gad_Prz = Unit_Prz * Gad_Qt;
      sprintf(Gd_Prz,"%.2f",Gad_Prz);
      
      for ( p_prezzo = Gd_Prz;*p_prezzo;p_prezzo++)
         if (*p_prezzo == ',') *p_prezzo = '.';

      gtk_entry_set_text (GTK_ENTRY (entry_euro),Gd_Prz);
    }

  return FALSE;
}


void
on_no_conf_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(ana_conf);
}


void
on_si_conf_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[400];
  gchar prezzo[100];
  gchar *p_prezzo;
   /* Lo switch page setta le variabili per il confronto
   * dunque al ritorno saltano i settaggi precedenti e va fatta
   * la lettura di tutti i campi*/
  Gad_Qt = atoi(get_testo(Contribuzione,"entry_qt"));
  note_text = lookup_widget(ana_user,"note_text");
  Nome_User = get_testo(ana_user,"nm_user");
  Ind_User = get_testo(ana_user,"ind_user");
  Citta_User = get_testo(ana_user,"citta");
  Prov_User = get_testo(ana_user,"prov");
  Cap_User = get_testo(ana_user,"cap");
  Tel_User = get_testo(ana_user,"tel");
  Fax_User = get_testo(ana_user,"fax");
  Mail_User = get_testo(ana_user,"email");
  Iva_User = get_testo(ana_user,"email");
  Note_User = gtk_editable_get_chars(GTK_EDITABLE(note_text),0,-1);
  Tipo_Contr = get_testo(Contribuzione,"combo_tipo");

  sprintf(prezzo,"%s",get_testo(Contribuzione,"entry_euro"));
      
   for ( p_prezzo = prezzo;*p_prezzo;p_prezzo++)
      if (*p_prezzo == ',') *p_prezzo = '.';
  
  Gadget = get_testo(Contribuzione,"combo_gad");
  /* Evitiamo di inserire i null */
  if (!Fax_User) Fax_User = strdup("Nessuno");
  if (!Mail_User) Mail_User = strdup("Nessuna");
  if (!Fax_User) Fax_User = strdup("Nessuno");
  if (!Note_User) Note_User = strdup("Nessuna");
  if (!Gadget) Gadget = strdup("Nessuno");

  sprintf(comando,"INSERT INTO utenti (nome,indirizzo,citta,prov,cap,tel,fax,\
	  email,piva,note,data,tipo_c,gadget,qt,euro,lug) VALUES ('%s','%s','%s','%s',\
          '%s','%s','%s','%s','%s','%s','%s','%s','%s','%d','%s','%s');",Nome_User,\
	  Ind_User,Citta_User,Prov_User,Cap_User,Tel_User,Fax_User,Mail_User,\
	  Iva_User,Note_User,DATA,Tipo_Contr,Gadget,Gad_Qt,prezzo,Lug_User);

  PQexec(connessione,comando);
  gtk_widget_destroy(ana_conf);
  gtk_widget_destroy(Contribuzione);
  clear_user();
}


void
on_butt_inf_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_ok_button_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_destroy(info);
}

void
on_vr_contr_changed                    (GtkEditable     *editable,
                                        gpointer         user_data)
{ if (CHANGED)
  { gchar comando[200];
    gchar *cassa, *gadget;
    PGresult *res;
    gint n_tuple;

    vr_gad = lookup_widget(ana_user,"vr_gad");
    vr_qt = lookup_widget(ana_user,"vr_qt");
    vr_prz = lookup_widget(ana_user,"vr_prz");

    Var_Tipo_Contr = get_testo(ana_user,"vr_contr");
    sprintf(comando,"SELECT cassa,gadget,lug FROM tipologie WHERE\
    nome='%s' ORDER BY nome;",Var_Tipo_Contr);

    res = PQexec(connessione,comando);
    n_tuple = PQntuples(res);
    if (n_tuple > 0)
      { cassa = PQgetvalue(res, 0,0);
        gadget = PQgetvalue(res, 0,1);
        Lug_User = PQgetvalue(res, 0,2);

	if (strcmp(Var_Tipo_Contr,"DONAZIONE") == 0)
	  { gtk_entry_set_editable (GTK_ENTRY (vr_prz),TRUE);
            gtk_entry_set_text (GTK_ENTRY (vr_qt),"1");
	  }
	else gtk_entry_set_editable (GTK_ENTRY (vr_prz),FALSE);
	  
 
        if (strcmp(cassa,"NO") == 0 )
         { gtk_entry_set_text (GTK_ENTRY (vr_gad),"Nessuno");
           gtk_entry_set_text (GTK_ENTRY (vr_qt),"0");
           gtk_entry_set_text (GTK_ENTRY (vr_prz),"0");
         }
         if (Tipo_Contr)
          { if (strcmp(Tipo_Contr,Var_Tipo_Contr) == 0)
              ghiaccia(ana_user,var_usave,"var_usave",0);
  
            if (strcmp(Tipo_Contr,Var_Tipo_Contr) != 0)
              ghiaccia(ana_user,var_usave,"var_usave",1);
          }
     }
  }
}


void
on_vr_gad_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)

{ if (CHANGED)
   { GtkWidget *vr_prz; 
     GtkWidget *vr_qt; 
     gchar comando[200];
     PGresult *res;
     gint n_tuple;
     gchar *prezzo;

     vr_prz = lookup_widget(ana_user,"vr_prz");
     vr_qt = lookup_widget(ana_user,"vr_qt");
     var_usave = lookup_widget(ana_user,"var_usave");
     Var_Gadget = get_testo(ana_user,"vr_gad");

     sprintf(comando,"SELECT euro FROM gadget WHERE\
     nome='%s' ORDER BY nome;",Var_Gadget);

     res = PQexec(connessione,comando);
     n_tuple = PQntuples(res);
     if (n_tuple > 0)
       { prezzo = PQgetvalue(res, 0,0);
         gtk_entry_set_text (GTK_ENTRY (vr_prz),prezzo);
         gtk_entry_set_text (GTK_ENTRY (vr_qt),"1");
       }

     if (Gadget)
      {
        if (strcmp(Gadget,Var_Gadget) == 0)
         ghiaccia(ana_user,var_usave,"var_usave",0);

        if (strcmp(Gadget,Var_Gadget) != 0)
         ghiaccia(ana_user,var_usave,"var_usave",1);
      }
   }
 }

void
on_chiudi_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(totali_cassa);
}


void
on_combo_totale_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{ gchar *tipologia;
  gchar *totale;
  gchar comando[200];
  PGresult *res_tipo;
  GtkWidget *entry6;

  tipologia = get_testo(totali_cassa,"combo_totale");

  if (tipologia)
    { sprintf(comando,"SELECT sum(euro) from utenti where tipo_c='%s';",tipologia);
      res_tipo = PQexec(connessione,comando);
      totale = PQgetvalue(res_tipo,0,0);
      entry6 = lookup_widget(totali_cassa,"entry6");
      gtk_entry_set_text (GTK_ENTRY (entry6),totale);
    }
}


void
on_combo25_set_focus_child             (GtkContainer    *container,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{ vr_qt = lookup_widget(ana_user,"vr_qt");
  CHANGED = 1;
  gtk_window_set_focus(GTK_WINDOW(ana_user), vr_qt);
}


void
on_combo26_set_focus_child             (GtkContainer    *container,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{ vr_qt = lookup_widget(ana_user,"vr_qt");
  CHANGED = 1;
  gtk_window_set_focus(GTK_WINDOW(ana_user), vr_qt);
}

gboolean
on_contr_var_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ GtkWidget *butt_cl_varsv;
  butt_cl_varsv = lookup_widget(widget,"butt_cl_varsv");

  TIPOLOGIA_VAR = upper_string(get_testo(collaborazioni,"contr_var"));
  gtk_entry_set_text (GTK_ENTRY(widget),TIPOLOGIA_VAR);
  
  if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
                        { if (*TIPOLOGIA_VAR) {
                           if ( (isalpha(*TIPOLOGIA_VAR) != 0))
                             {
                               if ( strcmp(TIPOLOGIA_VAR,TIPOLOGIA) != 0 )
                               butt_cl_varsv = lookup_widget(widget,"butt_cl_varsv");
                               gtk_widget_set_sensitive(GTK_WIDGET(butt_cl_varsv),\
                                                        TRUE);
                              }
                           else gdk_beep();
                            }
                          else  gdk_beep();
			 }
  return FALSE;
}


void
on_card_clicked                        (GtkButton       *button,
                                        gpointer         user_data)
{ conf_card = create_conf_card();
  gtk_widget_show(conf_card);
}


void
on_card_no_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(conf_card);
}


void
on_card_si_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ gchar comando[300];
  gint n_tuple;
  PGresult *res;
  gchar *device;
  gchar *tipo;
  gint n_copie = 1;

  tipo = strdup("Card");
  device = get_testo(conf_card,"entry_card");
  sprintf(comando,"SELECT nome,indirizzo,email,tipo_c,euro FROM utenti\
          WHERE id='%d';",ID);
  res = PQexec(connessione,comando);
  n_tuple = PQntuples(res);
  if (n_tuple > 0)
    {  print_riepilogo(n_tuple,res,tipo,device,n_copie);
       gtk_widget_destroy(conf_card);
    }
}


void
on_rc_no_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
  gtk_widget_destroy(rc_sel);
}


void
on_rc_si_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{ gchar *nome;
  gchar *indi;
  gchar *mail;
  gchar *contr;
  gchar *euro;
  gchar *printer;
  gint vero = 0;

  nome = get_testo(ana_user,"nm_user");
  indi = get_testo(ana_user,"ind_user");
  mail = get_testo(ana_user,"email");

  if (Contribuzione)
    { contr = get_testo(Contribuzione,"combo_tipo");
      euro = get_testo(Contribuzione,"entry_euro");
      if (!contr) contr = strdup("NESSUNO");
      if (!euro) euro = strdup("0");
    }
  else { contr = strdup("NESSUNO");
         euro = strdup("0");
       }
  printer = get_testo(rc_sel,"entry7");

  if (*nome)
    if (*indi)
      if (*mail)
       if (*contr)
        if (*euro)
         vero = 1;

   if (vero)
     { print_ricevuta(printer,nome,indi,mail,contr,euro);
       gtk_widget_destroy(rc_sel);
     }
   else { info = create_info();
          gtk_widget_show(info);
          info_label = lookup_widget(info,"info_label");
          gtk_label_set(GTK_LABEL(info_label), "Dati insufficienti)");
          gdk_beep();
        }
}


void
on_butt_rc_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{ rc_sel = create_rc_sel();
  gtk_widget_show(rc_sel);
}


void
on_rc_contrib_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{ rc_sel = create_rc_sel();
  gtk_widget_show(rc_sel);
}


void
on_check_lug_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)

{ check_lug = lookup_widget(collaborazioni,"check_lug");
  check_cassa = lookup_widget(collaborazioni,"check_cassa");
  check_gadget = lookup_widget(collaborazioni,"check_gadget");

     if ( GTK_TOGGLE_BUTTON (check_lug)->active)
       MOV_LUG = strdup("SI");
       else MOV_LUG = strdup("NO");

     if ( GTK_TOGGLE_BUTTON (check_cassa)->active)
       MOV_CASSA = strdup("SI");
       else MOV_CASSA = strdup("NO");

     if ( GTK_TOGGLE_BUTTON (check_gadget)->active)
       COME_GAD = strdup("SI");
       else COME_GAD = strdup("NO");
}


void
on_check_varlug_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)

 { GtkWidget *check_varlug;
  /* Lookup */
  check_varlug = lookup_widget(collaborazioni,"check_varlug");
  entry_lug = lookup_widget(collaborazioni,"entry_lug");

  if ( GTK_TOGGLE_BUTTON (check_varlug)->active)
    { gtk_entry_set_text (GTK_ENTRY(entry_lug), "SI");
      MOV_LUG  = strdup("SI");
     }
  else { gtk_entry_set_text (GTK_ENTRY(entry_lug), "NO");
         MOV_LUG  = strdup("NO");
       }
}


void
on_radio_all_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)

{ gchar *comando;
  gint n_tuple;

  /* list  dichiarato globale: pulisco la lista */
  list = lookup_widget(ana_user,"list3");
  gtk_list_clear_items(GTK_LIST(list),0,List3_Items);
  clear_vuser();

  comando = strdup("SELECT nome,indirizzo,citta,prov,cap,tel,fax,email,\
                    piva,tipo_c,gadget,qt,euro,data,note,id,lug\
                    FROM utenti ORDER BY nome;");
  /* Variabile globale, la sfrutto per evitare un altra SELECT
   * nel select_child */
   Res_User = PQexec(connessione,comando);
   n_tuple = PQntuples(Res_User);
   if (n_tuple > 0) load_list(comando, ana_user, "list3"); 
   ghiaccia(ana_user,var_usave,"var_usave",0);
   vr_prz= lookup_widget(ana_user,"vr_prz");
   gtk_entry_set_editable (GTK_ENTRY (vr_prz),FALSE);
}


void
on_radio_users_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)

{ gchar *comando;
  GtkWidget *find_user;
  gint n_tuple;


  /* list  dichiarato globale: pulisco la lista */
  list = lookup_widget(ana_user,"list3");
  gtk_list_clear_items(GTK_LIST(list),0,List3_Items);

  clear_vuser();

  comando = strdup("SELECT nome,indirizzo,citta,prov,cap,tel,fax,email,\
                    piva,tipo_c,gadget,qt,euro,data,note,id,lug\
                    FROM utenti WHERE lug='SI' ORDER BY nome;");
  /* Variabile globale, la sfrutto per evitare un altra SELECT
   * nel select_child */
   Res_User = PQexec(connessione,comando);
   n_tuple = PQntuples(Res_User);
   if (n_tuple > 0) load_list(comando, ana_user, "list3"); 
   ghiaccia(ana_user,var_usave,"var_usave",0);
   vr_prz= lookup_widget(ana_user,"vr_prz");
   gtk_entry_set_editable (GTK_ENTRY (vr_prz),FALSE);

   find_user = lookup_widget(ana_user,"find_user");
   gtk_window_set_focus(GTK_WINDOW(ana_user), find_user);
}


gboolean
on_vr_data_key_press_event             (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{ Var_Data = get_testo(widget, "vr_data");
  vr_data = lookup_widget(widget,"vr_data");
  var_usave = lookup_widget(widget,"var_usave");

   if ( event->keyval == GDK_Return || event->keyval == GDK_KP_Enter)
         { if (check_date(Var_Data, vr_data))
             { if ( strcmp(Data_User,Var_Data) != 0 )
               gtk_widget_set_sensitive(GTK_WIDGET(var_usave),TRUE);
             }
           else gdk_beep();
         }

  return FALSE;
}
