/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * COPYING NOTES
 * ____________
 *   colors.c --  Quik color setup function
 *
 *   Copyright (C) 2003 Dott. Paolo Bongiorno <p.bongy@tin.it>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * REVISION NOTES:
 *
 * RELEASED 01/10/03  by Dott. Paolo Bongiorno
 *
 */

#include "colors.h"
#include <string.h>

void setcolor(int red, int green, int blue,
              GtkWidget *widget, gchar *modo )
{ 
 /* (C) 2001 Paolo Bongiorno */
    

 /* Conversione del classico valore RGB a 8 bit
    nel valore a 16 bit */

    red = 65535 * red / 255;
    green = 65535 * green / 255;
    blue = 65535 * blue / 255;
       
    /* Creazione Dello Style */
    rc_style = gtk_rc_style_new();

    /* NORMAL: Quando il mouse non si trova sul widget */
    if ( (strcmp(modo,"bg_normal")) == 0 )
               { rc_style->color_flags[GTK_STATE_NORMAL] |= GTK_RC_BG;
                 rc_style->bg[GTK_STATE_NORMAL].red = red;
                 rc_style->bg[GTK_STATE_NORMAL].green = green;
                 rc_style->bg[GTK_STATE_NORMAL].blue = blue;
               }
    if ( (strcmp(modo,"fg_normal")) == 0 )
             { rc_style->color_flags[GTK_STATE_NORMAL] |= GTK_RC_FG;
               rc_style->fg[GTK_STATE_NORMAL].red = red;
               rc_style->fg[GTK_STATE_NORMAL].green = green;
               rc_style->fg[GTK_STATE_NORMAL].blue = blue;
              }
    /* PRELIGHT: Quando il mouse  sul widget */
    if ( (strcmp(modo,"bg_prelight")) == 0 )
             { rc_style->color_flags[GTK_STATE_PRELIGHT] |= GTK_RC_BG;
               rc_style->bg[GTK_STATE_PRELIGHT].red = red;
               rc_style->bg[GTK_STATE_PRELIGHT].green = green;
               rc_style->bg[GTK_STATE_PRELIGHT].blue = blue;
              }
    /* ACTIVE: Quando il widget  attivo */
    if ( (strcmp(modo,"bg_active")) == 0 )
             { rc_style->color_flags[GTK_STATE_ACTIVE] |= GTK_RC_BG;
               rc_style->bg[GTK_STATE_ACTIVE].red = red;
               rc_style->bg[GTK_STATE_ACTIVE].green = green;
               rc_style->bg[GTK_STATE_ACTIVE].blue = blue;
              }
    if ( (strcmp(modo,"fg_active")) == 0 )
             {  rc_style->color_flags[GTK_STATE_ACTIVE] |= GTK_RC_FG;
                rc_style->fg[GTK_STATE_ACTIVE].red = red;
                rc_style->fg[GTK_STATE_ACTIVE].green = green;
                rc_style->fg[GTK_STATE_ACTIVE].blue = blue;
               }
    /* SELECTED: Quando il widget  premuto */
    if ( (strcmp(modo,"bg_selected")) == 0 )
             { rc_style->color_flags[GTK_STATE_SELECTED] |= GTK_RC_BG;
               rc_style->bg[GTK_STATE_SELECTED].red = red;
               rc_style->bg[GTK_STATE_SELECTED].green = green;
               rc_style->bg[GTK_STATE_SELECTED].blue = blue;
              }
    if ( (strcmp(modo,"fg_selected")) == 0 )
             {  rc_style->color_flags[GTK_STATE_SELECTED] |= GTK_RC_FG;
                rc_style->fg[GTK_STATE_SELECTED].red = red;
                rc_style->fg[GTK_STATE_SELECTED].green = green;
                rc_style->fg[GTK_STATE_SELECTED].blue = blue;
               }

      /* Modifica dello style */
      gtk_widget_modify_style (widget, rc_style);

      gtk_rc_style_unref (rc_style);
 }


