/* =============================< init_db.c >================================*
 * COPYING NOTES
 * ____________
 *   init_db.c --  Advanced connection and managing function for the 
 *   postgreSQL Database
 *
 *   Copyright (C) 2003 Dott. Paolo Bongiorno <p.bongy@tin.it>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 */

/* ==========================< REVISION NOTES >==============================*
 *
 * RELEASED 01/10/03  by Dott. Paolo Bongiorno
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include "init_db.h"
#include "callbacks.h"


   /* Indice Della Barra Di Scorrimento */
   float id_maker = 0;
   int i,x, err,n_tuple;

  /* Variabili per la connessione */

  gchar *Pghost;
  gchar *Pgport="5432";
  gchar *Pgoptions = NULL;
  gchar *Pgtty = NULL;
  gchar *db_name = NULL;
  gchar *system_user = NULL;
  gchar *db_user = NULL;
  gchar *table = NULL;
  gchar make_user[200];
  gint installa = 0;
  GdkFont *fixed_font;
  PGresult *res = NULL;


  /* Funzione unica per la chiusura della connessione da utente
     postgres e riapertura da utente di procedura */

  void sub_init(void) {

        /* Predisponiamo la connessione come utente di procedura */
        /* Settaggio utente da collegare */

        i = putenv("PGUSER=gtkuser");

        printf("Putenv ritorna %d\n", i);

        db_name = strdup("gtklin");

        printf("DbName = %s\n", db_name);

        /* Apriamo una nuova connessione */
        connessione = PQsetdbLogin(Pghost,Pgport,Pgoptions,Pgtty,db_name,\
        NULL,NULL);


        if (PQstatus(connessione) == CONNECTION_BAD)
                { /* Se fallisce usciamo */
                  printf("Sub Init_db: Non  possibile connettersi al server\n");
		  err = system("test -s ./memodb.gtl");
		    if (!err) system("rm ./memodb.gtl");
                  exit(0);
                }
         else printf(" Sub Connessione Effettuata\n");
       }

   /* Controllo creazione tabelle */
   void check_table(void)
	{ if (PQresultStatus(res) != PGRES_COMMAND_OK)
	    {  text1 = lookup_widget(start_log,"text1");
                gtk_text_insert (GTK_TEXT (text1), fixed_font, NULL, NULL,\
				"WARNING: ERRORE NELLA CREAZIONE DELLA TABELLA", -1);
	    }
	  else gtk_text_insert (GTK_TEXT (text1), fixed_font, NULL, NULL, table, -1);
	}
 


   /* Struttura Barra<->Timer */
typedef struct _ProgressData {
    GtkWidget *p_pgbar;
    int timer;
}  ProgressData;

   ProgressData *pdata;


/* Funzione di Progressione Della Barra Di Scorrimento */

gint progbar_timeout(gpointer data) {

++id_maker;

pdata->p_pgbar = (GtkWidget *)lookup_widget(start_log, "pgbar"); 
gtk_progress_set_value(GTK_PROGRESS (pdata->p_pgbar), id_maker/100); 

  if ( id_maker == 100 ) {
                           gtk_timeout_remove(pdata->timer);
                           g_free(pdata);

                           /* Riavvio */
			   gtk_widget_set_sensitive(GTK_WIDGET(okbtt), TRUE);
                           gtk_text_insert (GTK_TEXT (text1), fixed_font, NULL, NULL,\
					   "... Database Strutturato Con Successo\n", -1);
                           gdk_beep();
                           return 0;
                         }
  else return 1;
}



/* Funzione Di Connessione al backend e Inizializzazione del DataBase */

void data_init(gchar *Pg_host) {

  /* Per evitare di modificare tutte le chiamate ... */
  Pghost = Pg_host;

  /* Utente di sistema */
  system_user = getenv("USER");

  /* Finestra de debug */
  start_log = create_start_log();

   /* puntatore alla barra */
   pgbar = lookup_widget(GTK_WIDGET(start_log), "pgbar");

   setcolor(0,0,255,pgbar,"bg_normal");

   pdata = g_malloc( sizeof(ProgressData) );

   db_name = strdup("template1");

   /* Connessione come utente Postgress */
   i = putenv("PGUSER=postgres");

   printf("DbName is = %s\n", db_name);

   /* Ci connettiamo e controlliamo lo stato della connessione */

   connessione = PQsetdbLogin(Pghost,Pgport,Pgoptions,Pgtty,db_name,NULL,NULL);
 

   if (PQstatus(connessione) == CONNECTION_BAD)
       { /* Se fallisce usciamo */
            printf("Init_db I : Non  possibile connettersi al server\n");
 	    err = system("test -s ./memodb.gtl");
	    if (!err) system("rm ./memodb.gtl");
            exit(0);
       }
   else printf("Connesso a %s\n", db_name);


   /* Controlliamo la presenza dell' utente di procedura nel DB */

   res = PQexec(connessione, "SELECT usename from pg_shadow");

   n_tuple = PQntuples(res);

   printf("Numero Tuple = %d\n", n_tuple);

   for (i = 0; i < n_tuple; i++)
          { db_user = PQgetvalue(res, i,0);
            if ( (x = strcmp(db_user, "gtkuser")) == 0 )  i = n_tuple;
          }


    /* Se l' utente non esiste ... controllo se sono root e creo */
    if ( (x = strcmp(db_user, "gtkuser")) != 0 )
              {  if ( (strcmp(system_user,"root")) == 0) {
		  sprintf(make_user,"su -l postgres -c \"createuser -A -d gtkuser\"");
                  system(make_user);
		  }
	         else installa = 1;
              }

   /* Se il database non esiste ... inizializziamo */
   res = PQexec(connessione, "SELECT datname from pg_database");

   n_tuple = PQntuples(res);

   for (i = 0; i < n_tuple; i++)
          { db_name = PQgetvalue(res, i,0);
            if ( (x = strcmp(db_name, "gtklin")) == 0 )  i = n_tuple;
          }

  if ( (x = strcmp(db_name, "gtklin" )) != 0 ) {

	/* Controllo se sono root */
	if  ( (strcmp(system_user,"root")) == 0) {
        /* Chiudiamo la connessione il DB non supporta accessi ultipli per lo
           stesso user */
        PQclear(res);
        PQfinish(connessione);
        
        /* L' utente gtklin crea le tabelle */
        i = putenv("PGUSER=gtkuser");

        /* Creazione database della procedura */
        system("createdb gtklin");

   	/* Apriamo una nuova connessione */
         sub_init();
    
	/* Creazione database della procedura */

        printf("......... Strutturazione del DataBase\n");

	/* Loading font */
	fixed_font = gdk_font_load ("-misc-fixed-medium-r-*-*-*-100-*-*-*-*-*-*");
	/* Ghiacciamo deskbase */
	gtk_widget_set_sensitive(GTK_WIDGET(deskbase),FALSE);
	/* Show della finestra */
        gtk_widget_show(start_log);
        okbtt = lookup_widget(start_log,"okbtt");
        gtk_widget_set_sensitive(GTK_WIDGET(okbtt), FALSE);
	text1 = lookup_widget(start_log,"text1");

       /* Cominciamo a strutturare il database */


      /* Creazione Delle Sequenze */
      res = PQexec(connessione,"CREATE SEQUENCE user_seq start 1 increment 1\
                                maxvalue 2147483647 minvalue 1 cache 1;" );

      res = PQexec(connessione,"CREATE SEQUENCE tipo_seq start 1 increment 1\
                                maxvalue 2147483647 minvalue 1 cache 1;" );

      res = PQexec(connessione,"CREATE SEQUENCE gad_seq start 1 increment 1\
                                maxvalue 2147483647 minvalue 1 cache 1;" );

      /* Tabelle con autoincremento del record */
      res = PQexec(connessione,"CREATE TABLE utenti ( nome     varchar(80),\
                                                     indirizzo varchar(90),\
                                                     citta     varchar(30),\
                                                     prov      varchar(2),\
                                                     cap       varchar(5),\
                                                     tel       varchar(20),\
                                                     fax       varchar(20),\
                                                     email     varchar(40),\
                                                     piva      varchar(11),\
                                                     tipo_c    varchar(60),\
                                                     gadget    varchar(60),\
                                                     qt        varchar(3),\
                                                     euro             real,\
                                                     lug       varchar(3),\
                                                     note      varchar(500),\
                                                     data      varchar(10),\
                                                     id               int4\
                                DEFAULT nextval('user_seq'::text) NOT NULL);" );
      table = strdup("Creazione della tabella utenti Ok!\n");
      check_table();

      /* Tabella delle tipologie di collaborazione */
      res = PQexec(connessione,"CREATE TABLE tipologie ( nome     varchar(60),\
                                                     cassa    varchar(6),\
                                                     gadget   varchar(6),\
                                                     lug      varchar(6),\
                                                     id               int4\
                                DEFAULT nextval('tipo_seq'::text) NOT NULL);" );
      table = strdup("Creazione della tabella tipologie Ok!\n");
      check_table();

      /* Tabella dei gadgets */
      res = PQexec(connessione,"CREATE TABLE gadget ( nome     varchar(60),\
                                                     euro             real,\
                                                     id               int4\
                                DEFAULT nextval('gad_seq'::text) NOT NULL);" );
      table = strdup("Creazione della tabella gadget Ok!\n");
      check_table();


        /* Puntatore Alla Barra */
        pdata->p_pgbar = (GtkWidget *)lookup_widget(start_log, "pgbar"); 

        /* Configurazione della Barra */
        gtk_progress_configure (GTK_PROGRESS (pdata->p_pgbar), 0, 0,1);

       /* Per ciascuna delle tabelle che si creano l' indice della
          barra verr incrementato di una unit mentre l' operazione di
          scorrimento viene poi completata attraverso il timer. */
       ++id_maker;

       /* Progressione */
        pdata->timer = gtk_timeout_add (10, progbar_timeout, pdata->p_pgbar);

       }
    else installa = 1;
    }

  if (installa)
      { infowin = create_infowin();
        gtk_widget_set_sensitive(GTK_WIDGET(deskbase),FALSE);
        gtk_widget_show(infowin);
      }

  else /* Se il database esiste invece ci limitiamo a collegarci */
       {  
          PQclear(res);
          PQfinish(connessione);
          sub_init();
	}

}

